/*** Included Header Files ***/
#include <UdmBase.h>
#include <ESMoL.h>

#include <iostream>
#include <set>

/***************************************************************************************/

using namespace std;

int main( int argc, char **argv ) {

	string filename( "QuadIntegrator.mga" );
	// Process the model
	try {
		Udm::SmartDataNetwork sdn( ESMoL::diagram ); 
		sdn.OpenExisting( filename );

		//Get the root folder of both projects
		ESMoL::RootFolder erf = ESMoL::RootFolder::Cast(sdn.GetRootObject());
		
		set< ESMoL::DesignFolder > designFolderSet = erf.DesignFolder_children();

		for( set<ESMoL::DesignFolder>::iterator dfIter = designFolderSet.begin(); dfIter!= designFolderSet.end(); dfIter++) {
		
			// DESIGN FOLDER
			ESMoL::DesignFolder designFolder = (*dfIter);
			
			// SYSTEM
			set< ESMoL::System > sysSet = designFolder.System_children();
			for( set< ESMoL::System >::iterator sysIter = sysSet.begin(); sysIter != sysSet.end(); sysIter++ ) {

				// EXECUTION ASSIGNMENT LINKS
				set< ESMoL::ExecutionAssignment > eaSet = (*sysIter).ExecutionAssignment_children();
				for ( set< ESMoL::ExecutionAssignment >::iterator eaIter = eaSet.begin(); eaIter != eaSet.end(); eaIter++ ) {

						ESMoL::Executable ex = (*eaIter).dstExecutionAssignment_end();

						if ( ex.type() == ESMoL::MessageRef::meta )
						{
							ESMoL::ComponentRef cref = (*eaIter).dstExecutionAssignment__rp_helper();
							cout << "Found component ref: " << cref.name() << endl;
						}
				}				
			}
		}

		sdn.CloseNoUpdate();

	} catch( udm_exception &ex )	{

		std::cout << "Exception occured in udm" << std::endl;
		std::cout << ex.what() << std::endl;
	}
	return 0;
}

