#ifndef MOBIES_ESMOL_H
#define MOBIES_ESMOL_H

// header file ESMoL.h generated from diagram ESMoL
// generated with Udm version 3.13 on Tue Sep 01 11:35:15 2009

#include <UdmBase.h>

#if !defined(UDM_VERSION_MAJOR) || !defined(UDM_VERSION_MINOR)
#    error "Udm headers too old, they do not define UDM_VERSION"
#elif UDM_VERSION_MAJOR < 3
#    error "Udm headers too old, minimum version required 3.13"
#elif UDM_VERSION_MAJOR == 3 && UDM_VERSION_MINOR < 13
#    error "Udm headers too old, minimum version required 3.13"
#endif

#include <Uml.h>


#ifdef min
#undef min
#endif

#ifdef max
#undef max
#endif

namespace ESMoL {

	extern ::Uml::Diagram meta;
	class ComponentRef_RefersTo_Base;
	class CommMapping_Members_Base;
	class MessageRef_RefersTo_Base;
	class Types;
	class TypeStruct;
	class Matrix;
	class TypeBase;
	class TypeBaseRef;
	class OS;
	class Wire;
	class HardwareUnit;
	class PlatformLibrary;
	class Router;
	class Connectable;
	class IChan;
	class OChan;
	class BChan;
	class Plant;
	class IODevice;
	class PhysConnection;
	class AcquisitionConnection;
	class ActuationConnection;
	class PhysInterface;
	class Bus;
	class Node;
	class HWElement;
	class Channel;
	class IOPortExp;
	class IOPortInfo;
	class IOPortInfoRef;
	class IOPortAssignment;
	class IOPortInfoBase;
	class OldTask;
	class Primitive;
	class Block;
	class Parameter;
	class Reference;
	class Annotation;
	class Line;
	class OutPort;
	class StatePort;
	class Port;
	class EnablePort;
	class TriggerPort;
	class InPort;
	class ActionPort;
	class Dataflow;
	class Subsystem;
	class InputPort;
	class OutputPort;
	class TTBus;
	class OldBus;
	class ModelsFolder;
	class ModelInfo;
	class DeploymentLibrary;
	class NodeRef;
	class CommMapping;
	class Dependency;
	class ComponentAssignment;
	class ComponentRef;
	class System;
	class TTExecContext;
	class ExecutionContext;
	class AsyncPeriodicExecInfo;
	class TTExecInfo;
	class ExecutionInfo;
	class ExecutionAssignment;
	class SporadicExecInfo;
	class Executable;
	class PeriodicExecInfo;
	class AperiodicExecInfo;
	class ArchitectureLibrary;
	class SystemTypes;
	class Connector;
	class Message;
	class MsgPort;
	class DesignFolder;
	class Component;
	class ComponentBase;
	class Output;
	class Input;
	class MessageRef;
	class TimingConstraint;
	class RequirementsLibrary;
	class TimingSheet;
	class TaskRef;
	class CCode;
	class SubsystemRef;
	class COutputPort;
	class CInputPort;
	class State;
	class Transition;
	class History;
	class TransStart;
	class Junction;
	class ConnectorRef;
	class Stateflow;
	class TransConnector;
	class Data;
	class Event;
	class StateDE;
	class RootFolder;
	class MgaObject;

	class Visitor : public Udm::BaseVisitor {
	public:
		virtual ~Visitor() {}

		virtual void Visit_Types(const Types &) {}
		virtual void Visit_TypeStruct(const TypeStruct &) {}
		virtual void Visit_Matrix(const Matrix &) {}
		virtual void Visit_TypeBaseRef(const TypeBaseRef &) {}
		virtual void Visit_OS(const OS &) {}
		virtual void Visit_Wire(const Wire &) {}
		virtual void Visit_HardwareUnit(const HardwareUnit &) {}
		virtual void Visit_PlatformLibrary(const PlatformLibrary &) {}
		virtual void Visit_Router(const Router &) {}
		virtual void Visit_IChan(const IChan &) {}
		virtual void Visit_OChan(const OChan &) {}
		virtual void Visit_BChan(const BChan &) {}
		virtual void Visit_Plant(const Plant &) {}
		virtual void Visit_IODevice(const IODevice &) {}
		virtual void Visit_PhysConnection(const PhysConnection &) {}
		virtual void Visit_AcquisitionConnection(const AcquisitionConnection &) {}
		virtual void Visit_ActuationConnection(const ActuationConnection &) {}
		virtual void Visit_Node(const Node &) {}
		virtual void Visit_IOPortInfo(const IOPortInfo &) {}
		virtual void Visit_IOPortInfoRef(const IOPortInfoRef &) {}
		virtual void Visit_IOPortAssignment(const IOPortAssignment &) {}
		virtual void Visit_OldTask(const OldTask &) {}
		virtual void Visit_Primitive(const Primitive &) {}
		virtual void Visit_Parameter(const Parameter &) {}
		virtual void Visit_Reference(const Reference &) {}
		virtual void Visit_Annotation(const Annotation &) {}
		virtual void Visit_Line(const Line &) {}
		virtual void Visit_StatePort(const StatePort &) {}
		virtual void Visit_EnablePort(const EnablePort &) {}
		virtual void Visit_TriggerPort(const TriggerPort &) {}
		virtual void Visit_ActionPort(const ActionPort &) {}
		virtual void Visit_Dataflow(const Dataflow &) {}
		virtual void Visit_Subsystem(const Subsystem &) {}
		virtual void Visit_InputPort(const InputPort &) {}
		virtual void Visit_OutputPort(const OutputPort &) {}
		virtual void Visit_TTBus(const TTBus &) {}
		virtual void Visit_OldBus(const OldBus &) {}
		virtual void Visit_ModelsFolder(const ModelsFolder &) {}
		virtual void Visit_ModelInfo(const ModelInfo &) {}
		virtual void Visit_DeploymentLibrary(const DeploymentLibrary &) {}
		virtual void Visit_NodeRef(const NodeRef &) {}
		virtual void Visit_CommMapping(const CommMapping &) {}
		virtual void Visit_Dependency(const Dependency &) {}
		virtual void Visit_ComponentAssignment(const ComponentAssignment &) {}
		virtual void Visit_ComponentRef(const ComponentRef &) {}
		virtual void Visit_System(const System &) {}
		virtual void Visit_TTExecContext(const TTExecContext &) {}
		virtual void Visit_AsyncPeriodicExecInfo(const AsyncPeriodicExecInfo &) {}
		virtual void Visit_TTExecInfo(const TTExecInfo &) {}
		virtual void Visit_ExecutionAssignment(const ExecutionAssignment &) {}
		virtual void Visit_SporadicExecInfo(const SporadicExecInfo &) {}
		virtual void Visit_ArchitectureLibrary(const ArchitectureLibrary &) {}
		virtual void Visit_SystemTypes(const SystemTypes &) {}
		virtual void Visit_Connector(const Connector &) {}
		virtual void Visit_Message(const Message &) {}
		virtual void Visit_MsgPort(const MsgPort &) {}
		virtual void Visit_DesignFolder(const DesignFolder &) {}
		virtual void Visit_Component(const Component &) {}
		virtual void Visit_MessageRef(const MessageRef &) {}
		virtual void Visit_TimingConstraint(const TimingConstraint &) {}
		virtual void Visit_RequirementsLibrary(const RequirementsLibrary &) {}
		virtual void Visit_TimingSheet(const TimingSheet &) {}
		virtual void Visit_TaskRef(const TaskRef &) {}
		virtual void Visit_CCode(const CCode &) {}
		virtual void Visit_SubsystemRef(const SubsystemRef &) {}
		virtual void Visit_COutputPort(const COutputPort &) {}
		virtual void Visit_CInputPort(const CInputPort &) {}
		virtual void Visit_State(const State &) {}
		virtual void Visit_Transition(const Transition &) {}
		virtual void Visit_History(const History &) {}
		virtual void Visit_TransStart(const TransStart &) {}
		virtual void Visit_Junction(const Junction &) {}
		virtual void Visit_ConnectorRef(const ConnectorRef &) {}
		virtual void Visit_Stateflow(const Stateflow &) {}
		virtual void Visit_Data(const Data &) {}
		virtual void Visit_Event(const Event &) {}
		virtual void Visit_RootFolder(const RootFolder &) {}
		virtual void Visit_Object(const Udm::Object &) {}

	};

	void Initialize();
	void Initialize(const ::Uml::Diagram &dgr);

	extern Udm::UdmDiagram diagram;

	class ComponentRef_RefersTo_Base :  virtual public Udm::Object {
	public:
		ComponentRef_RefersTo_Base() {}
		ComponentRef_RefersTo_Base(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		ComponentRef_RefersTo_Base(const ComponentRef_RefersTo_Base &master) : UDM_OBJECT(master) {}

		static ComponentRef_RefersTo_Base Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ComponentRef_RefersTo_Base Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ComponentRef_RefersTo_Base CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ComponentRef_RefersTo_Base> Instances() { return Udm::InstantiatedAttr<ComponentRef_RefersTo_Base>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ComponentRef_RefersTo_Base, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ComponentRef_RefersTo_Base, Pred>(impl); }
		ComponentRef_RefersTo_Base CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ComponentRef_RefersTo_Base> Derived() { return Udm::DerivedAttr<ComponentRef_RefersTo_Base>(impl); }
		template <class Pred> Udm::DerivedAttr<ComponentRef_RefersTo_Base, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ComponentRef_RefersTo_Base, Pred>(impl); }
		Udm::ArchetypeAttr<ComponentRef_RefersTo_Base> Archetype() const { return Udm::ArchetypeAttr<ComponentRef_RefersTo_Base>(impl); }
		Udm::AssocAttr< ::ESMoL::ComponentRef> referedbyComponentRef() const { return Udm::AssocAttr< ::ESMoL::ComponentRef>(impl, meta_referedbyComponentRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::ComponentRef, Pred> referedbyComponentRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::ComponentRef, Pred>(impl, meta_referedbyComponentRef); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_referedbyComponentRef;

	};

	class CommMapping_Members_Base :  virtual public Udm::Object {
	public:
		CommMapping_Members_Base() {}
		CommMapping_Members_Base(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		CommMapping_Members_Base(const CommMapping_Members_Base &master) : UDM_OBJECT(master) {}

		static CommMapping_Members_Base Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static CommMapping_Members_Base Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		CommMapping_Members_Base CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<CommMapping_Members_Base> Instances() { return Udm::InstantiatedAttr<CommMapping_Members_Base>(impl); }
		template <class Pred> Udm::InstantiatedAttr<CommMapping_Members_Base, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<CommMapping_Members_Base, Pred>(impl); }
		CommMapping_Members_Base CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<CommMapping_Members_Base> Derived() { return Udm::DerivedAttr<CommMapping_Members_Base>(impl); }
		template <class Pred> Udm::DerivedAttr<CommMapping_Members_Base, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<CommMapping_Members_Base, Pred>(impl); }
		Udm::ArchetypeAttr<CommMapping_Members_Base> Archetype() const { return Udm::ArchetypeAttr<CommMapping_Members_Base>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base> srcCommMapping() const { return Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base>(impl, meta_srcCommMapping, meta_srcCommMapping_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base, Pred> srcCommMapping_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base, Pred>(impl, meta_srcCommMapping, meta_srcCommMapping_rev); }
		Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base> dstCommMapping() const { return Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base>(impl, meta_dstCommMapping, meta_dstCommMapping_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base, Pred> dstCommMapping_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::CommMapping, ::ESMoL::CommMapping_Members_Base, Pred>(impl, meta_dstCommMapping, meta_dstCommMapping_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcCommMapping;
		static ::Uml::AssociationRole meta_srcCommMapping_rev;
		static ::Uml::AssociationRole meta_dstCommMapping;
		static ::Uml::AssociationRole meta_dstCommMapping_rev;

	};

	class MessageRef_RefersTo_Base :  virtual public Udm::Object {
	public:
		MessageRef_RefersTo_Base() {}
		MessageRef_RefersTo_Base(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		MessageRef_RefersTo_Base(const MessageRef_RefersTo_Base &master) : UDM_OBJECT(master) {}

		static MessageRef_RefersTo_Base Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static MessageRef_RefersTo_Base Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		MessageRef_RefersTo_Base CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<MessageRef_RefersTo_Base> Instances() { return Udm::InstantiatedAttr<MessageRef_RefersTo_Base>(impl); }
		template <class Pred> Udm::InstantiatedAttr<MessageRef_RefersTo_Base, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<MessageRef_RefersTo_Base, Pred>(impl); }
		MessageRef_RefersTo_Base CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<MessageRef_RefersTo_Base> Derived() { return Udm::DerivedAttr<MessageRef_RefersTo_Base>(impl); }
		template <class Pred> Udm::DerivedAttr<MessageRef_RefersTo_Base, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<MessageRef_RefersTo_Base, Pred>(impl); }
		Udm::ArchetypeAttr<MessageRef_RefersTo_Base> Archetype() const { return Udm::ArchetypeAttr<MessageRef_RefersTo_Base>(impl); }
		Udm::AssocAttr< ::ESMoL::MessageRef> referedbyBusMessageRef() const { return Udm::AssocAttr< ::ESMoL::MessageRef>(impl, meta_referedbyBusMessageRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::MessageRef, Pred> referedbyBusMessageRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::MessageRef, Pred>(impl, meta_referedbyBusMessageRef); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_referedbyBusMessageRef;

	};

	class Types : public Udm::Object {
	public:
		Types() {}
		Types(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		Types(const Types &master) : UDM_OBJECT(master) {}

		static Types Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Types Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Types CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Types> Instances() { return Udm::InstantiatedAttr<Types>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Types, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Types, Pred>(impl); }
		Types CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Types> Derived() { return Udm::DerivedAttr<Types>(impl); }
		template <class Pred> Udm::DerivedAttr<Types, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Types, Pred>(impl); }
		Udm::ArchetypeAttr<Types> Archetype() const { return Udm::ArchetypeAttr<Types>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::TypeBase> TypeBase_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeBase>(impl, meta_TypeBase_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeBase, Pred> TypeBase_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeBase, Pred>(impl, meta_TypeBase_children); }
		Udm::ChildrenAttr< ::ESMoL::TypeStruct> TypeStruct_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeStruct>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeStruct, Pred> TypeStruct_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeStruct, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Matrix> Matrix_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Matrix>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Matrix, Pred> Matrix_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Matrix, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TypeBase> TypeBase_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeBase>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeBase, Pred> TypeBase_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeBase, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Types(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_TypeBase_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class PlatformLibrary : public Udm::Object {
	public:
		PlatformLibrary() {}
		PlatformLibrary(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		PlatformLibrary(const PlatformLibrary &master) : UDM_OBJECT(master) {}

		static PlatformLibrary Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static PlatformLibrary Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		PlatformLibrary CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<PlatformLibrary> Instances() { return Udm::InstantiatedAttr<PlatformLibrary>(impl); }
		template <class Pred> Udm::InstantiatedAttr<PlatformLibrary, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<PlatformLibrary, Pred>(impl); }
		PlatformLibrary CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<PlatformLibrary> Derived() { return Udm::DerivedAttr<PlatformLibrary>(impl); }
		template <class Pred> Udm::DerivedAttr<PlatformLibrary, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<PlatformLibrary, Pred>(impl); }
		Udm::ArchetypeAttr<PlatformLibrary> Archetype() const { return Udm::ArchetypeAttr<PlatformLibrary>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::HardwareUnit> HardwareUnit_children() const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred> HardwareUnit_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred>(impl, meta_HardwareUnit_children); }
		Udm::ChildrenAttr< ::ESMoL::HardwareUnit> HardwareUnit_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred> HardwareUnit_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::HWElement> HWElement_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::HWElement>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HWElement, Pred> HWElement_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HWElement, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_PlatformLibrary(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_HardwareUnit_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class Dataflow : public Udm::Object {
	public:
		Dataflow() {}
		Dataflow(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		Dataflow(const Dataflow &master) : UDM_OBJECT(master) {}

		static Dataflow Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Dataflow Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Dataflow CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Dataflow> Instances() { return Udm::InstantiatedAttr<Dataflow>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Dataflow, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Dataflow, Pred>(impl); }
		Dataflow CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Dataflow> Derived() { return Udm::DerivedAttr<Dataflow>(impl); }
		template <class Pred> Udm::DerivedAttr<Dataflow, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Dataflow, Pred>(impl); }
		Udm::ArchetypeAttr<Dataflow> Archetype() const { return Udm::ArchetypeAttr<Dataflow>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::Subsystem> Subsystem_children() const { return Udm::ChildrenAttr< ::ESMoL::Subsystem>(impl, meta_Subsystem_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred> Subsystem_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred>(impl, meta_Subsystem_children); }
		Udm::ChildrenAttr< ::ESMoL::Block> Block_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Block>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Block, Pred> Block_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Block, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Subsystem> Subsystem_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Subsystem>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred> Subsystem_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ComponentBase> ComponentBase_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentBase>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentBase, Pred> ComponentBase_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentBase, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::ModelsFolder> ModelsFolder_parent() const { return Udm::ParentAttr< ::ESMoL::ModelsFolder>(impl, meta_ModelsFolder_parent); }
		Udm::ParentAttr< ::ESMoL::ModelsFolder> parent() const { return Udm::ParentAttr< ::ESMoL::ModelsFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Dataflow(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_Subsystem_children;
		static ::Uml::CompositionParentRole meta_ModelsFolder_parent;

	};

	class ModelsFolder : public Udm::Object {
	public:
		ModelsFolder() {}
		ModelsFolder(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		ModelsFolder(const ModelsFolder &master) : UDM_OBJECT(master) {}

		static ModelsFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ModelsFolder Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ModelsFolder CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ModelsFolder> Instances() { return Udm::InstantiatedAttr<ModelsFolder>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ModelsFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ModelsFolder, Pred>(impl); }
		ModelsFolder CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ModelsFolder> Derived() { return Udm::DerivedAttr<ModelsFolder>(impl); }
		template <class Pred> Udm::DerivedAttr<ModelsFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ModelsFolder, Pred>(impl); }
		Udm::ArchetypeAttr<ModelsFolder> Archetype() const { return Udm::ArchetypeAttr<ModelsFolder>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::Stateflow> Stateflow_children() const { return Udm::ChildrenAttr< ::ESMoL::Stateflow>(impl, meta_Stateflow_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Stateflow, Pred> Stateflow_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Stateflow, Pred>(impl, meta_Stateflow_children); }
		Udm::ChildrenAttr< ::ESMoL::Dataflow> Dataflow_children() const { return Udm::ChildrenAttr< ::ESMoL::Dataflow>(impl, meta_Dataflow_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Dataflow, Pred> Dataflow_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Dataflow, Pred>(impl, meta_Dataflow_children); }
		Udm::ChildrenAttr< ::ESMoL::ModelInfo> ModelInfo_children() const { return Udm::ChildrenAttr< ::ESMoL::ModelInfo>(impl, meta_ModelInfo_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ModelInfo, Pred> ModelInfo_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ModelInfo, Pred>(impl, meta_ModelInfo_children); }
		Udm::ChildrenAttr< ::ESMoL::Dataflow> Dataflow_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Dataflow>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Dataflow, Pred> Dataflow_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Dataflow, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ModelInfo> ModelInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ModelInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ModelInfo, Pred> ModelInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ModelInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Stateflow> Stateflow_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Stateflow>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Stateflow, Pred> Stateflow_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Stateflow, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::DesignFolder> DesignFolder_parent() const { return Udm::ParentAttr< ::ESMoL::DesignFolder>(impl, meta_DesignFolder_parent); }
		Udm::ParentAttr< ::ESMoL::DesignFolder> parent() const { return Udm::ParentAttr< ::ESMoL::DesignFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_ModelsFolder(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_Stateflow_children;
		static ::Uml::CompositionChildRole meta_Dataflow_children;
		static ::Uml::CompositionChildRole meta_ModelInfo_children;
		static ::Uml::CompositionParentRole meta_DesignFolder_parent;

	};

	class DeploymentLibrary : public Udm::Object {
	public:
		DeploymentLibrary() {}
		DeploymentLibrary(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		DeploymentLibrary(const DeploymentLibrary &master) : UDM_OBJECT(master) {}

		static DeploymentLibrary Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static DeploymentLibrary Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		DeploymentLibrary CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<DeploymentLibrary> Instances() { return Udm::InstantiatedAttr<DeploymentLibrary>(impl); }
		template <class Pred> Udm::InstantiatedAttr<DeploymentLibrary, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<DeploymentLibrary, Pred>(impl); }
		DeploymentLibrary CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<DeploymentLibrary> Derived() { return Udm::DerivedAttr<DeploymentLibrary>(impl); }
		template <class Pred> Udm::DerivedAttr<DeploymentLibrary, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<DeploymentLibrary, Pred>(impl); }
		Udm::ArchetypeAttr<DeploymentLibrary> Archetype() const { return Udm::ArchetypeAttr<DeploymentLibrary>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::System> System_children() const { return Udm::ChildrenAttr< ::ESMoL::System>(impl, meta_System_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::System, Pred> System_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::System, Pred>(impl, meta_System_children); }
		Udm::ChildrenAttr< ::ESMoL::System> System_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::System>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::System, Pred> System_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::System, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_DeploymentLibrary(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_System_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class ArchitectureLibrary : public Udm::Object {
	public:
		ArchitectureLibrary() {}
		ArchitectureLibrary(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		ArchitectureLibrary(const ArchitectureLibrary &master) : UDM_OBJECT(master) {}

		static ArchitectureLibrary Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ArchitectureLibrary Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ArchitectureLibrary CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ArchitectureLibrary> Instances() { return Udm::InstantiatedAttr<ArchitectureLibrary>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ArchitectureLibrary, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ArchitectureLibrary, Pred>(impl); }
		ArchitectureLibrary CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ArchitectureLibrary> Derived() { return Udm::DerivedAttr<ArchitectureLibrary>(impl); }
		template <class Pred> Udm::DerivedAttr<ArchitectureLibrary, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ArchitectureLibrary, Pred>(impl); }
		Udm::ArchetypeAttr<ArchitectureLibrary> Archetype() const { return Udm::ArchetypeAttr<ArchitectureLibrary>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::SystemTypes> SystemTypes_children() const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes>(impl, meta_SystemTypes_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred> SystemTypes_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred>(impl, meta_SystemTypes_children); }
		Udm::ChildrenAttr< ::ESMoL::SystemTypes> SystemTypes_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred> SystemTypes_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_ArchitectureLibrary(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_SystemTypes_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class DesignFolder : public Udm::Object {
	public:
		DesignFolder() {}
		DesignFolder(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		DesignFolder(const DesignFolder &master) : UDM_OBJECT(master) {}

		static DesignFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static DesignFolder Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		DesignFolder CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<DesignFolder> Instances() { return Udm::InstantiatedAttr<DesignFolder>(impl); }
		template <class Pred> Udm::InstantiatedAttr<DesignFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<DesignFolder, Pred>(impl); }
		DesignFolder CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<DesignFolder> Derived() { return Udm::DerivedAttr<DesignFolder>(impl); }
		template <class Pred> Udm::DerivedAttr<DesignFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<DesignFolder, Pred>(impl); }
		Udm::ArchetypeAttr<DesignFolder> Archetype() const { return Udm::ArchetypeAttr<DesignFolder>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::HardwareUnit> HardwareUnit_children() const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred> HardwareUnit_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred>(impl, meta_HardwareUnit_children); }
		Udm::ChildrenAttr< ::ESMoL::SystemTypes> SystemTypes_children() const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes>(impl, meta_SystemTypes_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred> SystemTypes_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred>(impl, meta_SystemTypes_children); }
		Udm::ChildrenAttr< ::ESMoL::ModelsFolder> ModelsFolder_children() const { return Udm::ChildrenAttr< ::ESMoL::ModelsFolder>(impl, meta_ModelsFolder_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ModelsFolder, Pred> ModelsFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ModelsFolder, Pred>(impl, meta_ModelsFolder_children); }
		Udm::ChildrenAttr< ::ESMoL::System> System_children() const { return Udm::ChildrenAttr< ::ESMoL::System>(impl, meta_System_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::System, Pred> System_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::System, Pred>(impl, meta_System_children); }
		Udm::ChildrenAttr< ::ESMoL::TimingSheet> TimingSheet_children() const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet>(impl, meta_TimingSheet_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred> TimingSheet_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred>(impl, meta_TimingSheet_children); }
		Udm::ChildrenAttr< ::ESMoL::HardwareUnit> HardwareUnit_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred> HardwareUnit_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::HWElement> HWElement_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::HWElement>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HWElement, Pred> HWElement_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HWElement, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ModelsFolder> ModelsFolder_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ModelsFolder>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ModelsFolder, Pred> ModelsFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ModelsFolder, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::System> System_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::System>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::System, Pred> System_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::System, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::SystemTypes> SystemTypes_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred> SystemTypes_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::SystemTypes, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TimingSheet> TimingSheet_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred> TimingSheet_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_DesignFolder(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_HardwareUnit_children;
		static ::Uml::CompositionChildRole meta_SystemTypes_children;
		static ::Uml::CompositionChildRole meta_ModelsFolder_children;
		static ::Uml::CompositionChildRole meta_System_children;
		static ::Uml::CompositionChildRole meta_TimingSheet_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class RequirementsLibrary : public Udm::Object {
	public:
		RequirementsLibrary() {}
		RequirementsLibrary(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		RequirementsLibrary(const RequirementsLibrary &master) : UDM_OBJECT(master) {}

		static RequirementsLibrary Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static RequirementsLibrary Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		RequirementsLibrary CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<RequirementsLibrary> Instances() { return Udm::InstantiatedAttr<RequirementsLibrary>(impl); }
		template <class Pred> Udm::InstantiatedAttr<RequirementsLibrary, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<RequirementsLibrary, Pred>(impl); }
		RequirementsLibrary CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<RequirementsLibrary> Derived() { return Udm::DerivedAttr<RequirementsLibrary>(impl); }
		template <class Pred> Udm::DerivedAttr<RequirementsLibrary, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<RequirementsLibrary, Pred>(impl); }
		Udm::ArchetypeAttr<RequirementsLibrary> Archetype() const { return Udm::ArchetypeAttr<RequirementsLibrary>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::TimingSheet> TimingSheet_children() const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet>(impl, meta_TimingSheet_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred> TimingSheet_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred>(impl, meta_TimingSheet_children); }
		Udm::ChildrenAttr< ::ESMoL::TimingSheet> TimingSheet_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred> TimingSheet_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TimingSheet, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_RequirementsLibrary(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_TimingSheet_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class Stateflow : public Udm::Object {
	public:
		Stateflow() {}
		Stateflow(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		Stateflow(const Stateflow &master) : UDM_OBJECT(master) {}

		static Stateflow Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Stateflow Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Stateflow CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Stateflow> Instances() { return Udm::InstantiatedAttr<Stateflow>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Stateflow, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Stateflow, Pred>(impl); }
		Stateflow CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Stateflow> Derived() { return Udm::DerivedAttr<Stateflow>(impl); }
		template <class Pred> Udm::DerivedAttr<Stateflow, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Stateflow, Pred>(impl); }
		Udm::ArchetypeAttr<Stateflow> Archetype() const { return Udm::ArchetypeAttr<Stateflow>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::State> State_children() const { return Udm::ChildrenAttr< ::ESMoL::State>(impl, meta_State_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::State, Pred> State_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::State, Pred>(impl, meta_State_children); }
		Udm::ChildrenAttr< ::ESMoL::State> State_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::State>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::State, Pred> State_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::State, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TransConnector> TransConnector_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TransConnector>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred> TransConnector_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::ModelsFolder> ModelsFolder_parent() const { return Udm::ParentAttr< ::ESMoL::ModelsFolder>(impl, meta_ModelsFolder_parent); }
		Udm::ParentAttr< ::ESMoL::ModelsFolder> parent() const { return Udm::ParentAttr< ::ESMoL::ModelsFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Stateflow(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_State_children;
		static ::Uml::CompositionParentRole meta_ModelsFolder_parent;

	};

	class RootFolder : public Udm::Object {
	public:
		RootFolder() {}
		RootFolder(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		RootFolder(const RootFolder &master) : UDM_OBJECT(master) {}

		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static RootFolder Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		RootFolder CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<RootFolder>(impl); }
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<RootFolder, Pred>(impl); }
		RootFolder CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<RootFolder> Derived() { return Udm::DerivedAttr<RootFolder>(impl); }
		template <class Pred> Udm::DerivedAttr<RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<RootFolder, Pred>(impl); }
		Udm::ArchetypeAttr<RootFolder> Archetype() const { return Udm::ArchetypeAttr<RootFolder>(impl); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ChildrenAttr< ::ESMoL::PlatformLibrary> PlatformLibrary_children() const { return Udm::ChildrenAttr< ::ESMoL::PlatformLibrary>(impl, meta_PlatformLibrary_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::PlatformLibrary, Pred> PlatformLibrary_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::PlatformLibrary, Pred>(impl, meta_PlatformLibrary_children); }
		Udm::ChildrenAttr< ::ESMoL::Types> Types_children() const { return Udm::ChildrenAttr< ::ESMoL::Types>(impl, meta_Types_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Types, Pred> Types_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Types, Pred>(impl, meta_Types_children); }
		Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary> DeploymentLibrary_children() const { return Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary>(impl, meta_DeploymentLibrary_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary, Pred> DeploymentLibrary_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary, Pred>(impl, meta_DeploymentLibrary_children); }
		Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary> ArchitectureLibrary_children() const { return Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary>(impl, meta_ArchitectureLibrary_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary, Pred> ArchitectureLibrary_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary, Pred>(impl, meta_ArchitectureLibrary_children); }
		Udm::ChildrenAttr< ::ESMoL::DesignFolder> DesignFolder_children() const { return Udm::ChildrenAttr< ::ESMoL::DesignFolder>(impl, meta_DesignFolder_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::DesignFolder, Pred> DesignFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::DesignFolder, Pred>(impl, meta_DesignFolder_children); }
		Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary> RequirementsLibrary_children() const { return Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary>(impl, meta_RequirementsLibrary_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary, Pred> RequirementsLibrary_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary, Pred>(impl, meta_RequirementsLibrary_children); }
		Udm::ChildrenAttr< ::ESMoL::RootFolder> RootFolder_children() const { return Udm::ChildrenAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::RootFolder, Pred> RootFolder_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::RootFolder, Pred>(impl, meta_RootFolder_children); }
		Udm::ChildrenAttr< ::ESMoL::Types> Types_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Types>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Types, Pred> Types_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Types, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::PlatformLibrary> PlatformLibrary_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::PlatformLibrary>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::PlatformLibrary, Pred> PlatformLibrary_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::PlatformLibrary, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary> DeploymentLibrary_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary, Pred> DeploymentLibrary_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::DeploymentLibrary, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary> ArchitectureLibrary_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary, Pred> ArchitectureLibrary_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ArchitectureLibrary, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::DesignFolder> DesignFolder_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::DesignFolder>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::DesignFolder, Pred> DesignFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::DesignFolder, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary> RequirementsLibrary_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary, Pred> RequirementsLibrary_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::RequirementsLibrary, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::RootFolder> RootFolder_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::RootFolder>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::RootFolder, Pred> RootFolder_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::RootFolder, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::RootFolder> RootFolder_parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, meta_RootFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RootFolder> parent() const { return Udm::ParentAttr< ::ESMoL::RootFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_RootFolder(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_name;
		static ::Uml::CompositionChildRole meta_PlatformLibrary_children;
		static ::Uml::CompositionChildRole meta_Types_children;
		static ::Uml::CompositionChildRole meta_DeploymentLibrary_children;
		static ::Uml::CompositionChildRole meta_ArchitectureLibrary_children;
		static ::Uml::CompositionChildRole meta_DesignFolder_children;
		static ::Uml::CompositionChildRole meta_RequirementsLibrary_children;
		static ::Uml::CompositionChildRole meta_RootFolder_children;
		static ::Uml::CompositionParentRole meta_RootFolder_parent;

	};

	class MgaObject :  virtual public Udm::Object {
	public:
		MgaObject() {}
		MgaObject(Udm::ObjectImpl *impl) : UDM_OBJECT(impl) {}
		MgaObject(const MgaObject &master) : UDM_OBJECT(master) {}

		static MgaObject Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static MgaObject Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		MgaObject CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<MgaObject> Instances() { return Udm::InstantiatedAttr<MgaObject>(impl); }
		template <class Pred> Udm::InstantiatedAttr<MgaObject, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<MgaObject, Pred>(impl); }
		MgaObject CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<MgaObject> Derived() { return Udm::DerivedAttr<MgaObject>(impl); }
		template <class Pred> Udm::DerivedAttr<MgaObject, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<MgaObject, Pred>(impl); }
		Udm::ArchetypeAttr<MgaObject> Archetype() const { return Udm::ArchetypeAttr<MgaObject>(impl); }
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_position;
		static ::Uml::Attribute meta_name;

	};

	class TypeBase :  public MgaObject {
	public:
		TypeBase() {}
		TypeBase(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		TypeBase(const TypeBase &master) : MgaObject(master), UDM_OBJECT(master) {}

		static TypeBase Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TypeBase Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TypeBase CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TypeBase> Instances() { return Udm::InstantiatedAttr<TypeBase>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TypeBase, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TypeBase, Pred>(impl); }
		TypeBase CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TypeBase> Derived() { return Udm::DerivedAttr<TypeBase>(impl); }
		template <class Pred> Udm::DerivedAttr<TypeBase, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TypeBase, Pred>(impl); }
		Udm::ArchetypeAttr<TypeBase> Archetype() const { return Udm::ArchetypeAttr<TypeBase>(impl); }
		Udm::AssocAttr< ::ESMoL::TypeBaseRef> referedbyTypeStructRef() const { return Udm::AssocAttr< ::ESMoL::TypeBaseRef>(impl, meta_referedbyTypeStructRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::TypeBaseRef, Pred> referedbyTypeStructRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::TypeBaseRef, Pred>(impl, meta_referedbyTypeStructRef); }
		Udm::ParentAttr< ::ESMoL::Types> Types_parent() const { return Udm::ParentAttr< ::ESMoL::Types>(impl, meta_Types_parent); }
		Udm::ParentAttr< ::ESMoL::Types> parent() const { return Udm::ParentAttr< ::ESMoL::Types>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_referedbyTypeStructRef;
		static ::Uml::CompositionParentRole meta_Types_parent;

	};

	class TypeStruct :  public TypeBase {
	public:
		TypeStruct() {}
		TypeStruct(Udm::ObjectImpl *impl) : TypeBase(impl), UDM_OBJECT(impl) {}
		TypeStruct(const TypeStruct &master) : TypeBase(master), UDM_OBJECT(master) {}

		static TypeStruct Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TypeStruct Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TypeStruct CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TypeStruct> Instances() { return Udm::InstantiatedAttr<TypeStruct>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TypeStruct, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TypeStruct, Pred>(impl); }
		TypeStruct CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TypeStruct> Derived() { return Udm::DerivedAttr<TypeStruct>(impl); }
		template <class Pred> Udm::DerivedAttr<TypeStruct, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TypeStruct, Pred>(impl); }
		Udm::ArchetypeAttr<TypeStruct> Archetype() const { return Udm::ArchetypeAttr<TypeStruct>(impl); }
		Udm::IntegerAttr MemberCount() const { return Udm::IntegerAttr(impl, meta_MemberCount); }
		Udm::ChildrenAttr< ::ESMoL::TypeBaseRef> TypeBaseRef_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef>(impl, meta_TypeBaseRef_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred> TypeBaseRef_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred>(impl, meta_TypeBaseRef_children); }
		Udm::ChildrenAttr< ::ESMoL::TypeBaseRef> TypeBaseRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred> TypeBaseRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::Types> parent() const { return Udm::ParentAttr< ::ESMoL::Types>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TypeStruct(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_MemberCount;
		static ::Uml::CompositionChildRole meta_TypeBaseRef_children;

	};

	class Matrix :  public TypeBase {
	public:
		Matrix() {}
		Matrix(Udm::ObjectImpl *impl) : TypeBase(impl), UDM_OBJECT(impl) {}
		Matrix(const Matrix &master) : TypeBase(master), UDM_OBJECT(master) {}

		static Matrix Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Matrix Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Matrix CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Matrix> Instances() { return Udm::InstantiatedAttr<Matrix>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Matrix, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Matrix, Pred>(impl); }
		Matrix CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Matrix> Derived() { return Udm::DerivedAttr<Matrix>(impl); }
		template <class Pred> Udm::DerivedAttr<Matrix, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Matrix, Pred>(impl); }
		Udm::ArchetypeAttr<Matrix> Archetype() const { return Udm::ArchetypeAttr<Matrix>(impl); }
		Udm::IntegerAttr rows() const { return Udm::IntegerAttr(impl, meta_rows); }
		Udm::StringAttr Type() const { return Udm::StringAttr(impl, meta_Type); }
		Udm::IntegerAttr columns() const { return Udm::IntegerAttr(impl, meta_columns); }
		Udm::ParentAttr< ::ESMoL::Types> parent() const { return Udm::ParentAttr< ::ESMoL::Types>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Matrix(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_rows;
		static ::Uml::Attribute meta_Type;
		static ::Uml::Attribute meta_columns;

	};

	class TypeBaseRef :  public MgaObject {
	public:
		TypeBaseRef() {}
		TypeBaseRef(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		TypeBaseRef(const TypeBaseRef &master) : MgaObject(master), UDM_OBJECT(master) {}

		static TypeBaseRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TypeBaseRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TypeBaseRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TypeBaseRef> Instances() { return Udm::InstantiatedAttr<TypeBaseRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TypeBaseRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TypeBaseRef, Pred>(impl); }
		TypeBaseRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TypeBaseRef> Derived() { return Udm::DerivedAttr<TypeBaseRef>(impl); }
		template <class Pred> Udm::DerivedAttr<TypeBaseRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TypeBaseRef, Pred>(impl); }
		Udm::ArchetypeAttr<TypeBaseRef> Archetype() const { return Udm::ArchetypeAttr<TypeBaseRef>(impl); }
		Udm::IntegerAttr MemberIndex() const { return Udm::IntegerAttr(impl, meta_MemberIndex); }
		Udm::PointerAttr< ::ESMoL::TypeBase> ref() const { return Udm::PointerAttr< ::ESMoL::TypeBase>(impl, meta_ref); }
		Udm::ParentAttr< ::ESMoL::TypeStruct> TypeStruct_parent() const { return Udm::ParentAttr< ::ESMoL::TypeStruct>(impl, meta_TypeStruct_parent); }
		Udm::ParentAttr< ::ESMoL::Port> Port_parent() const { return Udm::ParentAttr< ::ESMoL::Port>(impl, meta_Port_parent); }
		Udm::ParentAttr< ::ESMoL::StateDE> StateDE_parent() const { return Udm::ParentAttr< ::ESMoL::StateDE>(impl, meta_StateDE_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TypeBaseRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_MemberIndex;
		static ::Uml::AssociationRole meta_ref;
		static ::Uml::CompositionParentRole meta_TypeStruct_parent;
		static ::Uml::CompositionParentRole meta_Port_parent;
		static ::Uml::CompositionParentRole meta_StateDE_parent;

	};

	class OS :  public MgaObject {
	public:
		OS() {}
		OS(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		OS(const OS &master) : MgaObject(master), UDM_OBJECT(master) {}

		static OS Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static OS Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		OS CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<OS> Instances() { return Udm::InstantiatedAttr<OS>(impl); }
		template <class Pred> Udm::InstantiatedAttr<OS, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<OS, Pred>(impl); }
		OS CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<OS> Derived() { return Udm::DerivedAttr<OS>(impl); }
		template <class Pred> Udm::DerivedAttr<OS, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<OS, Pred>(impl); }
		Udm::ArchetypeAttr<OS> Archetype() const { return Udm::ArchetypeAttr<OS>(impl); }
		Udm::StringAttr SendOverheadTime() const { return Udm::StringAttr(impl, meta_SendOverheadTime); }
		Udm::StringAttr ContextSwitchTime() const { return Udm::StringAttr(impl, meta_ContextSwitchTime); }
		Udm::StringAttr RecvOverheadTime() const { return Udm::StringAttr(impl, meta_RecvOverheadTime); }
		Udm::StringAttr TickResolution() const { return Udm::StringAttr(impl, meta_TickResolution); }
		Udm::ParentAttr< ::ESMoL::Node> Node_parent() const { return Udm::ParentAttr< ::ESMoL::Node>(impl, meta_Node_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_OS(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_SendOverheadTime;
		static ::Uml::Attribute meta_ContextSwitchTime;
		static ::Uml::Attribute meta_RecvOverheadTime;
		static ::Uml::Attribute meta_TickResolution;
		static ::Uml::CompositionParentRole meta_Node_parent;

	};

	class Wire :  public MgaObject {
	public:
		Wire() {}
		Wire(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Wire(const Wire &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Wire Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Wire Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Wire CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Wire> Instances() { return Udm::InstantiatedAttr<Wire>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Wire, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Wire, Pred>(impl); }
		Wire CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Wire> Derived() { return Udm::DerivedAttr<Wire>(impl); }
		template <class Pred> Udm::DerivedAttr<Wire, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Wire, Pred>(impl); }
		Udm::ArchetypeAttr<Wire> Archetype() const { return Udm::ArchetypeAttr<Wire>(impl); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::Connectable> dstWire_end() const { return Udm::AssocEndAttr< ::ESMoL::Connectable>(impl, meta_dstWire_end_); }
		Udm::AssocEndAttr< ::ESMoL::Connectable> srcWire_end() const { return Udm::AssocEndAttr< ::ESMoL::Connectable>(impl, meta_srcWire_end_); }
		void Accept(Visitor &v) { v.Visit_Wire(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;
		static ::Uml::AssociationRole meta_dstWire_end_;
		static ::Uml::AssociationRole meta_srcWire_end_;

	};

	class Connectable :  virtual  public MgaObject {
	public:
		Connectable() {}
		Connectable(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Connectable(const Connectable &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Connectable Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Connectable Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Connectable CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Connectable> Instances() { return Udm::InstantiatedAttr<Connectable>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Connectable, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Connectable, Pred>(impl); }
		Connectable CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Connectable> Derived() { return Udm::DerivedAttr<Connectable>(impl); }
		template <class Pred> Udm::DerivedAttr<Connectable, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Connectable, Pred>(impl); }
		Udm::ArchetypeAttr<Connectable> Archetype() const { return Udm::ArchetypeAttr<Connectable>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable> srcWire() const { return Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable>(impl, meta_srcWire, meta_srcWire_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable, Pred> srcWire_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable, Pred>(impl, meta_srcWire, meta_srcWire_rev); }
		Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable> dstWire() const { return Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable>(impl, meta_dstWire, meta_dstWire_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable, Pred> dstWire_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Wire, ::ESMoL::Connectable, Pred>(impl, meta_dstWire, meta_dstWire_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcWire;
		static ::Uml::AssociationRole meta_srcWire_rev;
		static ::Uml::AssociationRole meta_dstWire;
		static ::Uml::AssociationRole meta_dstWire_rev;

	};

	class PhysConnection :  public MgaObject {
	public:
		PhysConnection() {}
		PhysConnection(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		PhysConnection(const PhysConnection &master) : MgaObject(master), UDM_OBJECT(master) {}

		static PhysConnection Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static PhysConnection Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		PhysConnection CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<PhysConnection> Instances() { return Udm::InstantiatedAttr<PhysConnection>(impl); }
		template <class Pred> Udm::InstantiatedAttr<PhysConnection, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<PhysConnection, Pred>(impl); }
		PhysConnection CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<PhysConnection> Derived() { return Udm::DerivedAttr<PhysConnection>(impl); }
		template <class Pred> Udm::DerivedAttr<PhysConnection, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<PhysConnection, Pred>(impl); }
		Udm::ArchetypeAttr<PhysConnection> Archetype() const { return Udm::ArchetypeAttr<PhysConnection>(impl); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::PhysInterface> dstPhysConnection_end() const { return Udm::AssocEndAttr< ::ESMoL::PhysInterface>(impl, meta_dstPhysConnection_end_); }
		Udm::AssocEndAttr< ::ESMoL::PhysInterface> srcPhysConnection_end() const { return Udm::AssocEndAttr< ::ESMoL::PhysInterface>(impl, meta_srcPhysConnection_end_); }
		void Accept(Visitor &v) { v.Visit_PhysConnection(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;
		static ::Uml::AssociationRole meta_dstPhysConnection_end_;
		static ::Uml::AssociationRole meta_srcPhysConnection_end_;

	};

	class AcquisitionConnection :  public MgaObject {
	public:
		AcquisitionConnection() {}
		AcquisitionConnection(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		AcquisitionConnection(const AcquisitionConnection &master) : MgaObject(master), UDM_OBJECT(master) {}

		static AcquisitionConnection Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static AcquisitionConnection Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		AcquisitionConnection CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<AcquisitionConnection> Instances() { return Udm::InstantiatedAttr<AcquisitionConnection>(impl); }
		template <class Pred> Udm::InstantiatedAttr<AcquisitionConnection, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<AcquisitionConnection, Pred>(impl); }
		AcquisitionConnection CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<AcquisitionConnection> Derived() { return Udm::DerivedAttr<AcquisitionConnection>(impl); }
		template <class Pred> Udm::DerivedAttr<AcquisitionConnection, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<AcquisitionConnection, Pred>(impl); }
		Udm::ArchetypeAttr<AcquisitionConnection> Archetype() const { return Udm::ArchetypeAttr<AcquisitionConnection>(impl); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::IChan> dstAcquisitionConnection_end() const { return Udm::AssocEndAttr< ::ESMoL::IChan>(impl, meta_dstAcquisitionConnection_end_); }
		Udm::AssocEndAttr< ::ESMoL::IODevice> srcAcquisitionConnection_end() const { return Udm::AssocEndAttr< ::ESMoL::IODevice>(impl, meta_srcAcquisitionConnection_end_); }
		void Accept(Visitor &v) { v.Visit_AcquisitionConnection(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;
		static ::Uml::AssociationRole meta_dstAcquisitionConnection_end_;
		static ::Uml::AssociationRole meta_srcAcquisitionConnection_end_;

	};

	class ActuationConnection :  public MgaObject {
	public:
		ActuationConnection() {}
		ActuationConnection(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ActuationConnection(const ActuationConnection &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ActuationConnection Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ActuationConnection Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ActuationConnection CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ActuationConnection> Instances() { return Udm::InstantiatedAttr<ActuationConnection>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ActuationConnection, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ActuationConnection, Pred>(impl); }
		ActuationConnection CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ActuationConnection> Derived() { return Udm::DerivedAttr<ActuationConnection>(impl); }
		template <class Pred> Udm::DerivedAttr<ActuationConnection, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ActuationConnection, Pred>(impl); }
		Udm::ArchetypeAttr<ActuationConnection> Archetype() const { return Udm::ArchetypeAttr<ActuationConnection>(impl); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::IODevice> dstActuationConnection_end() const { return Udm::AssocEndAttr< ::ESMoL::IODevice>(impl, meta_dstActuationConnection_end_); }
		Udm::AssocEndAttr< ::ESMoL::OChan> srcActuationConnection_end() const { return Udm::AssocEndAttr< ::ESMoL::OChan>(impl, meta_srcActuationConnection_end_); }
		void Accept(Visitor &v) { v.Visit_ActuationConnection(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;
		static ::Uml::AssociationRole meta_dstActuationConnection_end_;
		static ::Uml::AssociationRole meta_srcActuationConnection_end_;

	};

	class PhysInterface :  virtual  public MgaObject {
	public:
		PhysInterface() {}
		PhysInterface(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		PhysInterface(const PhysInterface &master) : MgaObject(master), UDM_OBJECT(master) {}

		static PhysInterface Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static PhysInterface Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		PhysInterface CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<PhysInterface> Instances() { return Udm::InstantiatedAttr<PhysInterface>(impl); }
		template <class Pred> Udm::InstantiatedAttr<PhysInterface, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<PhysInterface, Pred>(impl); }
		PhysInterface CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<PhysInterface> Derived() { return Udm::DerivedAttr<PhysInterface>(impl); }
		template <class Pred> Udm::DerivedAttr<PhysInterface, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<PhysInterface, Pred>(impl); }
		Udm::ArchetypeAttr<PhysInterface> Archetype() const { return Udm::ArchetypeAttr<PhysInterface>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface> srcPhysConnection() const { return Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface>(impl, meta_srcPhysConnection, meta_srcPhysConnection_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface, Pred> srcPhysConnection_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface, Pred>(impl, meta_srcPhysConnection, meta_srcPhysConnection_rev); }
		Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface> dstPhysConnection() const { return Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface>(impl, meta_dstPhysConnection, meta_dstPhysConnection_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface, Pred> dstPhysConnection_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::PhysConnection, ::ESMoL::PhysInterface, Pred>(impl, meta_dstPhysConnection, meta_dstPhysConnection_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcPhysConnection;
		static ::Uml::AssociationRole meta_srcPhysConnection_rev;
		static ::Uml::AssociationRole meta_dstPhysConnection;
		static ::Uml::AssociationRole meta_dstPhysConnection_rev;

	};

	class Plant :  public PhysInterface {
	public:
		Plant() {}
		Plant(Udm::ObjectImpl *impl) : PhysInterface(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Plant(const Plant &master) : PhysInterface(master), MgaObject(master), UDM_OBJECT(master) {}

		static Plant Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Plant Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Plant CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Plant> Instances() { return Udm::InstantiatedAttr<Plant>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Plant, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Plant, Pred>(impl); }
		Plant CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Plant> Derived() { return Udm::DerivedAttr<Plant>(impl); }
		template <class Pred> Udm::DerivedAttr<Plant, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Plant, Pred>(impl); }
		Udm::ArchetypeAttr<Plant> Archetype() const { return Udm::ArchetypeAttr<Plant>(impl); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Plant(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;

	};

	class HWElement :  virtual  public MgaObject {
	public:
		HWElement() {}
		HWElement(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		HWElement(const HWElement &master) : MgaObject(master), UDM_OBJECT(master) {}

		static HWElement Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static HWElement Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		HWElement CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<HWElement> Instances() { return Udm::InstantiatedAttr<HWElement>(impl); }
		template <class Pred> Udm::InstantiatedAttr<HWElement, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<HWElement, Pred>(impl); }
		HWElement CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<HWElement> Derived() { return Udm::DerivedAttr<HWElement>(impl); }
		template <class Pred> Udm::DerivedAttr<HWElement, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<HWElement, Pred>(impl); }
		Udm::ArchetypeAttr<HWElement> Archetype() const { return Udm::ArchetypeAttr<HWElement>(impl); }
		Udm::StringAttr Configuration() const { return Udm::StringAttr(impl, meta_Configuration); }
		Udm::ChildrenAttr< ::ESMoL::ExecutionContext> ExecutionContext_children() const { return Udm::ChildrenAttr< ::ESMoL::ExecutionContext>(impl, meta_ExecutionContext_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ExecutionContext, Pred> ExecutionContext_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ExecutionContext, Pred>(impl, meta_ExecutionContext_children); }
		Udm::ChildrenAttr< ::ESMoL::TTExecContext> TTExecContext_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TTExecContext>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TTExecContext, Pred> TTExecContext_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TTExecContext, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ExecutionContext> ExecutionContext_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ExecutionContext>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ExecutionContext, Pred> ExecutionContext_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ExecutionContext, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Configuration;
		static ::Uml::CompositionChildRole meta_ExecutionContext_children;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;

	};

	class HardwareUnit :  public HWElement {
	public:
		HardwareUnit() {}
		HardwareUnit(Udm::ObjectImpl *impl) : HWElement(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		HardwareUnit(const HardwareUnit &master) : HWElement(master), MgaObject(master), UDM_OBJECT(master) {}

		static HardwareUnit Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static HardwareUnit Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		HardwareUnit CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<HardwareUnit> Instances() { return Udm::InstantiatedAttr<HardwareUnit>(impl); }
		template <class Pred> Udm::InstantiatedAttr<HardwareUnit, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<HardwareUnit, Pred>(impl); }
		HardwareUnit CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<HardwareUnit> Derived() { return Udm::DerivedAttr<HardwareUnit>(impl); }
		template <class Pred> Udm::DerivedAttr<HardwareUnit, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<HardwareUnit, Pred>(impl); }
		Udm::ArchetypeAttr<HardwareUnit> Archetype() const { return Udm::ArchetypeAttr<HardwareUnit>(impl); }
		Udm::ChildrenAttr< ::ESMoL::Channel> Channel_children() const { return Udm::ChildrenAttr< ::ESMoL::Channel>(impl, meta_Channel_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Channel, Pred> Channel_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Channel, Pred>(impl, meta_Channel_children); }
		Udm::ChildrenAttr< ::ESMoL::HWElement> HWElement_children() const { return Udm::ChildrenAttr< ::ESMoL::HWElement>(impl, meta_HWElement_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HWElement, Pred> HWElement_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HWElement, Pred>(impl, meta_HWElement_children); }
		Udm::ChildrenAttr< ::ESMoL::Plant> Plant_children() const { return Udm::ChildrenAttr< ::ESMoL::Plant>(impl, meta_Plant_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Plant, Pred> Plant_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Plant, Pred>(impl, meta_Plant_children); }
		Udm::ChildrenAttr< ::ESMoL::PhysConnection> PhysConnection_children() const { return Udm::ChildrenAttr< ::ESMoL::PhysConnection>(impl, meta_PhysConnection_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::PhysConnection, Pred> PhysConnection_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::PhysConnection, Pred>(impl, meta_PhysConnection_children); }
		Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection> AcquisitionConnection_children() const { return Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection>(impl, meta_AcquisitionConnection_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection, Pred> AcquisitionConnection_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection, Pred>(impl, meta_AcquisitionConnection_children); }
		Udm::ChildrenAttr< ::ESMoL::ActuationConnection> ActuationConnection_children() const { return Udm::ChildrenAttr< ::ESMoL::ActuationConnection>(impl, meta_ActuationConnection_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ActuationConnection, Pred> ActuationConnection_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ActuationConnection, Pred>(impl, meta_ActuationConnection_children); }
		Udm::ChildrenAttr< ::ESMoL::Wire> Wire_children() const { return Udm::ChildrenAttr< ::ESMoL::Wire>(impl, meta_Wire_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Wire, Pred> Wire_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Wire, Pred>(impl, meta_Wire_children); }
		Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base> CommMapping_Members_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred> CommMapping_Members_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Wire> Wire_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Wire>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Wire, Pred> Wire_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Wire, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::HardwareUnit> HardwareUnit_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred> HardwareUnit_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HardwareUnit, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Router> Router_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Router>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Router, Pred> Router_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Router, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Connectable> Connectable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Connectable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Connectable, Pred> Connectable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Connectable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::IChan> IChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::IChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::IChan, Pred> IChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::IChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::OChan> OChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::OChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::OChan, Pred> OChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::OChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::BChan> BChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::BChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::BChan, Pred> BChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::BChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Plant> Plant_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Plant>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Plant, Pred> Plant_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Plant, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::IODevice> IODevice_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::IODevice>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::IODevice, Pred> IODevice_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::IODevice, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::PhysConnection> PhysConnection_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::PhysConnection>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::PhysConnection, Pred> PhysConnection_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::PhysConnection, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection> AcquisitionConnection_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection, Pred> AcquisitionConnection_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::AcquisitionConnection, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ActuationConnection> ActuationConnection_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ActuationConnection>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ActuationConnection, Pred> ActuationConnection_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ActuationConnection, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::PhysInterface> PhysInterface_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::PhysInterface>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::PhysInterface, Pred> PhysInterface_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::PhysInterface, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Bus> Bus_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Bus>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Bus, Pred> Bus_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Bus, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Node> Node_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Node>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Node, Pred> Node_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Node, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::HWElement> HWElement_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::HWElement>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::HWElement, Pred> HWElement_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::HWElement, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Channel> Channel_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Channel>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Channel, Pred> Channel_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Channel, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TTBus> TTBus_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TTBus>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TTBus, Pred> TTBus_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TTBus, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::OldBus> OldBus_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::OldBus>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::OldBus, Pred> OldBus_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::OldBus, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Executable> Executable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Executable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Executable, Pred> Executable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Executable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::DesignFolder> DesignFolder_parent() const { return Udm::ParentAttr< ::ESMoL::DesignFolder>(impl, meta_DesignFolder_parent); }
		Udm::ParentAttr< ::ESMoL::PlatformLibrary> PlatformLibrary_parent() const { return Udm::ParentAttr< ::ESMoL::PlatformLibrary>(impl, meta_PlatformLibrary_parent); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_HardwareUnit(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionChildRole meta_Channel_children;
		static ::Uml::CompositionChildRole meta_HWElement_children;
		static ::Uml::CompositionChildRole meta_Plant_children;
		static ::Uml::CompositionChildRole meta_PhysConnection_children;
		static ::Uml::CompositionChildRole meta_AcquisitionConnection_children;
		static ::Uml::CompositionChildRole meta_ActuationConnection_children;
		static ::Uml::CompositionChildRole meta_Wire_children;
		static ::Uml::CompositionParentRole meta_DesignFolder_parent;
		static ::Uml::CompositionParentRole meta_PlatformLibrary_parent;

	};

	class Router :  public HWElement {
	public:
		Router() {}
		Router(Udm::ObjectImpl *impl) : HWElement(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Router(const Router &master) : HWElement(master), MgaObject(master), UDM_OBJECT(master) {}

		static Router Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Router Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Router CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Router> Instances() { return Udm::InstantiatedAttr<Router>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Router, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Router, Pred>(impl); }
		Router CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Router> Derived() { return Udm::DerivedAttr<Router>(impl); }
		template <class Pred> Udm::DerivedAttr<Router, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Router, Pred>(impl); }
		Udm::ArchetypeAttr<Router> Archetype() const { return Udm::ArchetypeAttr<Router>(impl); }
		Udm::ChildrenAttr< ::ESMoL::BChan> BChan_children() const { return Udm::ChildrenAttr< ::ESMoL::BChan>(impl, meta_BChan_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::BChan, Pred> BChan_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::BChan, Pred>(impl, meta_BChan_children); }
		Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base> CommMapping_Members_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred> CommMapping_Members_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Connectable> Connectable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Connectable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Connectable, Pred> Connectable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Connectable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::BChan> BChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::BChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::BChan, Pred> BChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::BChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Channel> Channel_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Channel>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Channel, Pred> Channel_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Channel, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Executable> Executable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Executable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Executable, Pred> Executable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Executable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Router(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionChildRole meta_BChan_children;

	};

	class IODevice :  public PhysInterface,  public HWElement {
	public:
		IODevice() {}
		IODevice(Udm::ObjectImpl *impl) : PhysInterface(impl),HWElement(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		IODevice(const IODevice &master) : PhysInterface(master),HWElement(master), MgaObject(master), UDM_OBJECT(master) {}

		static IODevice Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IODevice Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IODevice CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IODevice> Instances() { return Udm::InstantiatedAttr<IODevice>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IODevice, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IODevice, Pred>(impl); }
		IODevice CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IODevice> Derived() { return Udm::DerivedAttr<IODevice>(impl); }
		template <class Pred> Udm::DerivedAttr<IODevice, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IODevice, Pred>(impl); }
		Udm::ArchetypeAttr<IODevice> Archetype() const { return Udm::ArchetypeAttr<IODevice>(impl); }
		Udm::StringAttr DeviceType() const { return Udm::StringAttr(impl, meta_DeviceType); }
		Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IChan> dstAcquisitionConnection() const { return Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IChan>(impl, meta_dstAcquisitionConnection, meta_dstAcquisitionConnection_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IChan, Pred> dstAcquisitionConnection_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IChan, Pred>(impl, meta_dstAcquisitionConnection, meta_dstAcquisitionConnection_rev); }
		Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::OChan> srcActuationConnection() const { return Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::OChan>(impl, meta_srcActuationConnection, meta_srcActuationConnection_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::OChan, Pred> srcActuationConnection_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::OChan, Pred>(impl, meta_srcActuationConnection, meta_srcActuationConnection_rev); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_IODevice(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_DeviceType;
		static ::Uml::AssociationRole meta_dstAcquisitionConnection;
		static ::Uml::AssociationRole meta_dstAcquisitionConnection_rev;
		static ::Uml::AssociationRole meta_srcActuationConnection;
		static ::Uml::AssociationRole meta_srcActuationConnection_rev;

	};

	class Bus :  public Connectable,  public HWElement {
	public:
		Bus() {}
		Bus(Udm::ObjectImpl *impl) : Connectable(impl),HWElement(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Bus(const Bus &master) : Connectable(master),HWElement(master), MgaObject(master), UDM_OBJECT(master) {}

		static Bus Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Bus Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Bus CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Bus> Instances() { return Udm::InstantiatedAttr<Bus>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Bus, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Bus, Pred>(impl); }
		Bus CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Bus> Derived() { return Udm::DerivedAttr<Bus>(impl); }
		template <class Pred> Udm::DerivedAttr<Bus, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Bus, Pred>(impl); }
		Udm::ArchetypeAttr<Bus> Archetype() const { return Udm::ArchetypeAttr<Bus>(impl); }
		Udm::StringAttr OverheadTime() const { return Udm::StringAttr(impl, meta_OverheadTime); }
		Udm::StringAttr DataRate() const { return Udm::StringAttr(impl, meta_DataRate); }
		Udm::StringAttr MinFrameSize() const { return Udm::StringAttr(impl, meta_MinFrameSize); }
		Udm::StringAttr SwitchMemorySize() const { return Udm::StringAttr(impl, meta_SwitchMemorySize); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_OverheadTime;
		static ::Uml::Attribute meta_DataRate;
		static ::Uml::Attribute meta_MinFrameSize;
		static ::Uml::Attribute meta_SwitchMemorySize;

	};

	class Node :  public HWElement {
	public:
		Node() {}
		Node(Udm::ObjectImpl *impl) : HWElement(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Node(const Node &master) : HWElement(master), MgaObject(master), UDM_OBJECT(master) {}

		static Node Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Node Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Node CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Node> Instances() { return Udm::InstantiatedAttr<Node>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Node, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Node, Pred>(impl); }
		Node CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Node> Derived() { return Udm::DerivedAttr<Node>(impl); }
		template <class Pred> Udm::DerivedAttr<Node, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Node, Pred>(impl); }
		Udm::ArchetypeAttr<Node> Archetype() const { return Udm::ArchetypeAttr<Node>(impl); }
		Udm::IntegerAttr ROM() const { return Udm::IntegerAttr(impl, meta_ROM); }
		Udm::StringAttr Simulator() const { return Udm::StringAttr(impl, meta_Simulator); }
		Udm::IntegerAttr RAM() const { return Udm::IntegerAttr(impl, meta_RAM); }
		Udm::IntegerAttr Speed() const { return Udm::IntegerAttr(impl, meta_Speed); }
		Udm::StringAttr CPU() const { return Udm::StringAttr(impl, meta_CPU); }
		Udm::StringAttr PlatformType() const { return Udm::StringAttr(impl, meta_PlatformType); }
		Udm::AssocAttr< ::ESMoL::NodeRef> referedbyNodeRef() const { return Udm::AssocAttr< ::ESMoL::NodeRef>(impl, meta_referedbyNodeRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::NodeRef, Pred> referedbyNodeRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::NodeRef, Pred>(impl, meta_referedbyNodeRef); }
		Udm::ChildAttr< ::ESMoL::OS> OS_child() const { return Udm::ChildAttr< ::ESMoL::OS>(impl, meta_OS_child); }
		Udm::ChildrenAttr< ::ESMoL::Channel> Channel_children() const { return Udm::ChildrenAttr< ::ESMoL::Channel>(impl, meta_Channel_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Channel, Pred> Channel_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Channel, Pred>(impl, meta_Channel_children); }
		Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base> CommMapping_Members_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred> CommMapping_Members_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::OS> OS_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::OS>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::OS, Pred> OS_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::OS, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Connectable> Connectable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Connectable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Connectable, Pred> Connectable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Connectable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::IChan> IChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::IChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::IChan, Pred> IChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::IChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::OChan> OChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::OChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::OChan, Pred> OChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::OChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::BChan> BChan_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::BChan>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::BChan, Pred> BChan_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::BChan, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Channel> Channel_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Channel>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Channel, Pred> Channel_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Channel, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Executable> Executable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Executable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Executable, Pred> Executable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Executable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Node(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_ROM;
		static ::Uml::Attribute meta_Simulator;
		static ::Uml::Attribute meta_RAM;
		static ::Uml::Attribute meta_Speed;
		static ::Uml::Attribute meta_CPU;
		static ::Uml::Attribute meta_PlatformType;
		static ::Uml::AssociationRole meta_referedbyNodeRef;
		static ::Uml::CompositionChildRole meta_OS_child;
		static ::Uml::CompositionChildRole meta_Channel_children;

	};

	class IOPortExp :  virtual  public MgaObject {
	public:
		IOPortExp() {}
		IOPortExp(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		IOPortExp(const IOPortExp &master) : MgaObject(master), UDM_OBJECT(master) {}

		static IOPortExp Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IOPortExp Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IOPortExp CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IOPortExp> Instances() { return Udm::InstantiatedAttr<IOPortExp>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IOPortExp, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IOPortExp, Pred>(impl); }
		IOPortExp CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IOPortExp> Derived() { return Udm::DerivedAttr<IOPortExp>(impl); }
		template <class Pred> Udm::DerivedAttr<IOPortExp, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IOPortExp, Pred>(impl); }
		Udm::ArchetypeAttr<IOPortExp> Archetype() const { return Udm::ArchetypeAttr<IOPortExp>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortInfoBase> srcIOPortAssignment() const { return Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortInfoBase>(impl, meta_srcIOPortAssignment, meta_srcIOPortAssignment_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortInfoBase, Pred> srcIOPortAssignment_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortInfoBase, Pred>(impl, meta_srcIOPortAssignment, meta_srcIOPortAssignment_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcIOPortAssignment;
		static ::Uml::AssociationRole meta_srcIOPortAssignment_rev;

	};

	class IOPortAssignment :  public MgaObject {
	public:
		IOPortAssignment() {}
		IOPortAssignment(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		IOPortAssignment(const IOPortAssignment &master) : MgaObject(master), UDM_OBJECT(master) {}

		static IOPortAssignment Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IOPortAssignment Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IOPortAssignment CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IOPortAssignment> Instances() { return Udm::InstantiatedAttr<IOPortAssignment>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IOPortAssignment, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IOPortAssignment, Pred>(impl); }
		IOPortAssignment CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IOPortAssignment> Derived() { return Udm::DerivedAttr<IOPortAssignment>(impl); }
		template <class Pred> Udm::DerivedAttr<IOPortAssignment, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IOPortAssignment, Pred>(impl); }
		Udm::ArchetypeAttr<IOPortAssignment> Archetype() const { return Udm::ArchetypeAttr<IOPortAssignment>(impl); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::IOPortExp> dstIOPortAssignment_end() const { return Udm::AssocEndAttr< ::ESMoL::IOPortExp>(impl, meta_dstIOPortAssignment_end_); }
		Udm::AssocEndAttr< ::ESMoL::IOPortInfoBase> srcIOPortAssignment_end() const { return Udm::AssocEndAttr< ::ESMoL::IOPortInfoBase>(impl, meta_srcIOPortAssignment_end_); }
		void Accept(Visitor &v) { v.Visit_IOPortAssignment(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstIOPortAssignment_end_;
		static ::Uml::AssociationRole meta_srcIOPortAssignment_end_;

	};

	class IOPortInfoBase :  public MgaObject {
	public:
		IOPortInfoBase() {}
		IOPortInfoBase(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		IOPortInfoBase(const IOPortInfoBase &master) : MgaObject(master), UDM_OBJECT(master) {}

		static IOPortInfoBase Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IOPortInfoBase Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IOPortInfoBase CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IOPortInfoBase> Instances() { return Udm::InstantiatedAttr<IOPortInfoBase>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IOPortInfoBase, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IOPortInfoBase, Pred>(impl); }
		IOPortInfoBase CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IOPortInfoBase> Derived() { return Udm::DerivedAttr<IOPortInfoBase>(impl); }
		template <class Pred> Udm::DerivedAttr<IOPortInfoBase, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IOPortInfoBase, Pred>(impl); }
		Udm::ArchetypeAttr<IOPortInfoBase> Archetype() const { return Udm::ArchetypeAttr<IOPortInfoBase>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortExp> dstIOPortAssignment() const { return Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortExp>(impl, meta_dstIOPortAssignment, meta_dstIOPortAssignment_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortExp, Pred> dstIOPortAssignment_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::IOPortAssignment, ::ESMoL::IOPortExp, Pred>(impl, meta_dstIOPortAssignment, meta_dstIOPortAssignment_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstIOPortAssignment;
		static ::Uml::AssociationRole meta_dstIOPortAssignment_rev;

	};

	class IOPortInfo :  public IOPortInfoBase {
	public:
		IOPortInfo() {}
		IOPortInfo(Udm::ObjectImpl *impl) : IOPortInfoBase(impl), UDM_OBJECT(impl) {}
		IOPortInfo(const IOPortInfo &master) : IOPortInfoBase(master), UDM_OBJECT(master) {}

		static IOPortInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IOPortInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IOPortInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IOPortInfo> Instances() { return Udm::InstantiatedAttr<IOPortInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IOPortInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IOPortInfo, Pred>(impl); }
		IOPortInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IOPortInfo> Derived() { return Udm::DerivedAttr<IOPortInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<IOPortInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IOPortInfo, Pred>(impl); }
		Udm::ArchetypeAttr<IOPortInfo> Archetype() const { return Udm::ArchetypeAttr<IOPortInfo>(impl); }
		Udm::StringAttr DataInit() const { return Udm::StringAttr(impl, meta_DataInit); }
		Udm::StringAttr DataSize() const { return Udm::StringAttr(impl, meta_DataSize); }
		Udm::StringAttr DataMin() const { return Udm::StringAttr(impl, meta_DataMin); }
		Udm::StringAttr DataMax() const { return Udm::StringAttr(impl, meta_DataMax); }
		Udm::StringAttr Scale() const { return Udm::StringAttr(impl, meta_Scale); }
		Udm::StringAttr Offset() const { return Udm::StringAttr(impl, meta_Offset); }
		Udm::AssocAttr< ::ESMoL::IOPortInfoRef> referedbyIOPortInfoRef() const { return Udm::AssocAttr< ::ESMoL::IOPortInfoRef>(impl, meta_referedbyIOPortInfoRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::IOPortInfoRef, Pred> referedbyIOPortInfoRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::IOPortInfoRef, Pred>(impl, meta_referedbyIOPortInfoRef); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_IOPortInfo(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_DataInit;
		static ::Uml::Attribute meta_DataSize;
		static ::Uml::Attribute meta_DataMin;
		static ::Uml::Attribute meta_DataMax;
		static ::Uml::Attribute meta_Scale;
		static ::Uml::Attribute meta_Offset;
		static ::Uml::AssociationRole meta_referedbyIOPortInfoRef;

	};

	class IOPortInfoRef :  public IOPortInfoBase {
	public:
		IOPortInfoRef() {}
		IOPortInfoRef(Udm::ObjectImpl *impl) : IOPortInfoBase(impl), UDM_OBJECT(impl) {}
		IOPortInfoRef(const IOPortInfoRef &master) : IOPortInfoBase(master), UDM_OBJECT(master) {}

		static IOPortInfoRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IOPortInfoRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IOPortInfoRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IOPortInfoRef> Instances() { return Udm::InstantiatedAttr<IOPortInfoRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IOPortInfoRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IOPortInfoRef, Pred>(impl); }
		IOPortInfoRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IOPortInfoRef> Derived() { return Udm::DerivedAttr<IOPortInfoRef>(impl); }
		template <class Pred> Udm::DerivedAttr<IOPortInfoRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IOPortInfoRef, Pred>(impl); }
		Udm::ArchetypeAttr<IOPortInfoRef> Archetype() const { return Udm::ArchetypeAttr<IOPortInfoRef>(impl); }
		Udm::PointerAttr< ::ESMoL::IOPortInfo> ref() const { return Udm::PointerAttr< ::ESMoL::IOPortInfo>(impl, meta_ref); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_IOPortInfoRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;

	};

	class OldTask :  public MgaObject {
	public:
		OldTask() {}
		OldTask(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		OldTask(const OldTask &master) : MgaObject(master), UDM_OBJECT(master) {}

		static OldTask Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static OldTask Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		OldTask CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<OldTask> Instances() { return Udm::InstantiatedAttr<OldTask>(impl); }
		template <class Pred> Udm::InstantiatedAttr<OldTask, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<OldTask, Pred>(impl); }
		OldTask CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<OldTask> Derived() { return Udm::DerivedAttr<OldTask>(impl); }
		template <class Pred> Udm::DerivedAttr<OldTask, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<OldTask, Pred>(impl); }
		Udm::ArchetypeAttr<OldTask> Archetype() const { return Udm::ArchetypeAttr<OldTask>(impl); }
		Udm::StringAttr TaskType() const { return Udm::StringAttr(impl, meta_TaskType); }
		Udm::IntegerAttr Priority() const { return Udm::IntegerAttr(impl, meta_Priority); }
		Udm::IntegerAttr Activation() const { return Udm::IntegerAttr(impl, meta_Activation); }
		Udm::BooleanAttr AutoStart() const { return Udm::BooleanAttr(impl, meta_AutoStart); }
		Udm::StringAttr Preemption() const { return Udm::StringAttr(impl, meta_Preemption); }
		Udm::BooleanAttr Cyclic() const { return Udm::BooleanAttr(impl, meta_Cyclic); }
		Udm::IntegerAttr CycleTime() const { return Udm::IntegerAttr(impl, meta_CycleTime); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_OldTask(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_TaskType;
		static ::Uml::Attribute meta_Priority;
		static ::Uml::Attribute meta_Activation;
		static ::Uml::Attribute meta_AutoStart;
		static ::Uml::Attribute meta_Preemption;
		static ::Uml::Attribute meta_Cyclic;
		static ::Uml::Attribute meta_CycleTime;

	};

	class Block :  virtual  public MgaObject {
	public:
		Block() {}
		Block(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Block(const Block &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Block Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Block Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Block CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Block> Instances() { return Udm::InstantiatedAttr<Block>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Block, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Block, Pred>(impl); }
		Block CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Block> Derived() { return Udm::DerivedAttr<Block>(impl); }
		template <class Pred> Udm::DerivedAttr<Block, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Block, Pred>(impl); }
		Udm::ArchetypeAttr<Block> Archetype() const { return Udm::ArchetypeAttr<Block>(impl); }
		Udm::StringAttr Tag() const { return Udm::StringAttr(impl, meta_Tag); }
		Udm::StringAttr BlockType() const { return Udm::StringAttr(impl, meta_BlockType); }
		Udm::StringAttr Name() const { return Udm::StringAttr(impl, meta_Name); }
		Udm::StringAttr Description() const { return Udm::StringAttr(impl, meta_Description); }
		Udm::IntegerAttr Priority() const { return Udm::IntegerAttr(impl, meta_Priority); }
		Udm::RealAttr SampleTime() const { return Udm::RealAttr(impl, meta_SampleTime); }
		Udm::StringAttr UserData() const { return Udm::StringAttr(impl, meta_UserData); }
		Udm::ChildrenAttr< ::ESMoL::Line> Line() const { return Udm::ChildrenAttr< ::ESMoL::Line>(impl, meta_Line); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Line, Pred> Line_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Line, Pred>(impl, meta_Line); }
		Udm::ChildrenAttr< ::ESMoL::Parameter> Parameter() const { return Udm::ChildrenAttr< ::ESMoL::Parameter>(impl, meta_Parameter); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Parameter, Pred> Parameter_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Parameter, Pred>(impl, meta_Parameter); }
		Udm::ChildrenAttr< ::ESMoL::Annotation> Annotation_children() const { return Udm::ChildrenAttr< ::ESMoL::Annotation>(impl, meta_Annotation_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Annotation, Pred> Annotation_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Annotation, Pred>(impl, meta_Annotation_children); }
		Udm::ChildrenAttr< ::ESMoL::ConnectorRef> ConnectorRef_children() const { return Udm::ChildrenAttr< ::ESMoL::ConnectorRef>(impl, meta_ConnectorRef_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ConnectorRef, Pred> ConnectorRef_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ConnectorRef, Pred>(impl, meta_ConnectorRef_children); }
		Udm::ChildrenAttr< ::ESMoL::Port> Port_children() const { return Udm::ChildrenAttr< ::ESMoL::Port>(impl, meta_Port_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Port, Pred> Port_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Port, Pred>(impl, meta_Port_children); }
		Udm::ChildrenAttr< ::ESMoL::Parameter> Parameter_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Parameter>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Parameter, Pred> Parameter_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Parameter, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Annotation> Annotation_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Annotation>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Annotation, Pred> Annotation_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Annotation, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Line> Line_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Line>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Line, Pred> Line_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Line, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::OutPort> OutPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::OutPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::OutPort, Pred> OutPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::OutPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::StatePort> StatePort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::StatePort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::StatePort, Pred> StatePort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::StatePort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Port> Port_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Port>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Port, Pred> Port_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Port, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::EnablePort> EnablePort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::EnablePort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::EnablePort, Pred> EnablePort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::EnablePort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TriggerPort> TriggerPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TriggerPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TriggerPort, Pred> TriggerPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TriggerPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::InPort> InPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::InPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::InPort, Pred> InPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::InPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ActionPort> ActionPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ActionPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ActionPort, Pred> ActionPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ActionPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::InputPort> InputPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::InputPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::InputPort, Pred> InputPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::InputPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::OutputPort> OutputPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::OutputPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::OutputPort, Pred> OutputPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::OutputPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ConnectorRef> ConnectorRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ConnectorRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ConnectorRef, Pred> ConnectorRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ConnectorRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TransConnector> TransConnector_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TransConnector>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred> TransConnector_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::Subsystem> Subsystem_parent() const { return Udm::ParentAttr< ::ESMoL::Subsystem>(impl, meta_Subsystem_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Tag;
		static ::Uml::Attribute meta_BlockType;
		static ::Uml::Attribute meta_Name;
		static ::Uml::Attribute meta_Description;
		static ::Uml::Attribute meta_Priority;
		static ::Uml::Attribute meta_SampleTime;
		static ::Uml::Attribute meta_UserData;
		static ::Uml::CompositionChildRole meta_Line;
		static ::Uml::CompositionChildRole meta_Parameter;
		static ::Uml::CompositionChildRole meta_Annotation_children;
		static ::Uml::CompositionChildRole meta_ConnectorRef_children;
		static ::Uml::CompositionChildRole meta_Port_children;
		static ::Uml::CompositionParentRole meta_Subsystem_parent;

	};

	class Primitive :  public Block {
	public:
		Primitive() {}
		Primitive(Udm::ObjectImpl *impl) : Block(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Primitive(const Primitive &master) : Block(master), MgaObject(master), UDM_OBJECT(master) {}

		static Primitive Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Primitive Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Primitive CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Primitive> Instances() { return Udm::InstantiatedAttr<Primitive>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Primitive, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Primitive, Pred>(impl); }
		Primitive CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Primitive> Derived() { return Udm::DerivedAttr<Primitive>(impl); }
		template <class Pred> Udm::DerivedAttr<Primitive, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Primitive, Pred>(impl); }
		Udm::ArchetypeAttr<Primitive> Archetype() const { return Udm::ArchetypeAttr<Primitive>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Primitive(*this); }

		static ::Uml::Class meta;

	};

	class Parameter :  public MgaObject {
	public:
		Parameter() {}
		Parameter(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Parameter(const Parameter &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Parameter Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Parameter Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Parameter CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Parameter> Instances() { return Udm::InstantiatedAttr<Parameter>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Parameter, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Parameter, Pred>(impl); }
		Parameter CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Parameter> Derived() { return Udm::DerivedAttr<Parameter>(impl); }
		template <class Pred> Udm::DerivedAttr<Parameter, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Parameter, Pred>(impl); }
		Udm::ArchetypeAttr<Parameter> Archetype() const { return Udm::ArchetypeAttr<Parameter>(impl); }
		Udm::StringAttr Value() const { return Udm::StringAttr(impl, meta_Value); }
		Udm::ParentAttr< ::ESMoL::Block> Parameter_Block_parent() const { return Udm::ParentAttr< ::ESMoL::Block>(impl, meta_Parameter_Block_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Parameter(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Value;
		static ::Uml::CompositionParentRole meta_Parameter_Block_parent;

	};

	class Reference :  public Block {
	public:
		Reference() {}
		Reference(Udm::ObjectImpl *impl) : Block(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Reference(const Reference &master) : Block(master), MgaObject(master), UDM_OBJECT(master) {}

		static Reference Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Reference Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Reference CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Reference> Instances() { return Udm::InstantiatedAttr<Reference>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Reference, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Reference, Pred>(impl); }
		Reference CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Reference> Derived() { return Udm::DerivedAttr<Reference>(impl); }
		template <class Pred> Udm::DerivedAttr<Reference, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Reference, Pred>(impl); }
		Udm::ArchetypeAttr<Reference> Archetype() const { return Udm::ArchetypeAttr<Reference>(impl); }
		Udm::StringAttr SourceBlock() const { return Udm::StringAttr(impl, meta_SourceBlock); }
		Udm::StringAttr SourceType() const { return Udm::StringAttr(impl, meta_SourceType); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Reference(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_SourceBlock;
		static ::Uml::Attribute meta_SourceType;

	};

	class Annotation :  public MgaObject {
	public:
		Annotation() {}
		Annotation(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Annotation(const Annotation &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Annotation Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Annotation Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Annotation CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Annotation> Instances() { return Udm::InstantiatedAttr<Annotation>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Annotation, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Annotation, Pred>(impl); }
		Annotation CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Annotation> Derived() { return Udm::DerivedAttr<Annotation>(impl); }
		template <class Pred> Udm::DerivedAttr<Annotation, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Annotation, Pred>(impl); }
		Udm::ArchetypeAttr<Annotation> Archetype() const { return Udm::ArchetypeAttr<Annotation>(impl); }
		Udm::StringAttr Text() const { return Udm::StringAttr(impl, meta_Text); }
		Udm::ParentAttr< ::ESMoL::Block> Block_parent() const { return Udm::ParentAttr< ::ESMoL::Block>(impl, meta_Block_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Annotation(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Text;
		static ::Uml::CompositionParentRole meta_Block_parent;

	};

	class Line :  public MgaObject {
	public:
		Line() {}
		Line(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Line(const Line &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Line Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Line Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Line CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Line> Instances() { return Udm::InstantiatedAttr<Line>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Line, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Line, Pred>(impl); }
		Line CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Line> Derived() { return Udm::DerivedAttr<Line>(impl); }
		template <class Pred> Udm::DerivedAttr<Line, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Line, Pred>(impl); }
		Udm::ArchetypeAttr<Line> Archetype() const { return Udm::ArchetypeAttr<Line>(impl); }
		Udm::StringAttr Name() const { return Udm::StringAttr(impl, meta_Name); }
		Udm::ParentAttr< ::ESMoL::Block> Line_Block_parent() const { return Udm::ParentAttr< ::ESMoL::Block>(impl, meta_Line_Block_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::Port> dstLine_end() const { return Udm::AssocEndAttr< ::ESMoL::Port>(impl, meta_dstLine_end_); }
		Udm::AssocEndAttr< ::ESMoL::Port> srcLine_end() const { return Udm::AssocEndAttr< ::ESMoL::Port>(impl, meta_srcLine_end_); }
		void Accept(Visitor &v) { v.Visit_Line(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Name;
		static ::Uml::CompositionParentRole meta_Line_Block_parent;
		static ::Uml::AssociationRole meta_dstLine_end_;
		static ::Uml::AssociationRole meta_srcLine_end_;

	};

	class Port :  virtual  public MgaObject {
	public:
		Port() {}
		Port(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Port(const Port &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Port Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Port Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Port CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Port> Instances() { return Udm::InstantiatedAttr<Port>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Port, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Port, Pred>(impl); }
		Port CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Port> Derived() { return Udm::DerivedAttr<Port>(impl); }
		template <class Pred> Udm::DerivedAttr<Port, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Port, Pred>(impl); }
		Udm::ArchetypeAttr<Port> Archetype() const { return Udm::ArchetypeAttr<Port>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port> srcLine() const { return Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port>(impl, meta_srcLine, meta_srcLine_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port, Pred> srcLine_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port, Pred>(impl, meta_srcLine, meta_srcLine_rev); }
		Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port> dstLine() const { return Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port>(impl, meta_dstLine, meta_dstLine_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port, Pred> dstLine_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Line, ::ESMoL::Port, Pred>(impl, meta_dstLine, meta_dstLine_rev); }
		Udm::ChildAttr< ::ESMoL::TypeBaseRef> TypeBaseRef_child() const { return Udm::ChildAttr< ::ESMoL::TypeBaseRef>(impl, meta_TypeBaseRef_child); }
		Udm::ChildrenAttr< ::ESMoL::TypeBaseRef> TypeBaseRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred> TypeBaseRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::Block> Block_parent() const { return Udm::ParentAttr< ::ESMoL::Block>(impl, meta_Block_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcLine;
		static ::Uml::AssociationRole meta_srcLine_rev;
		static ::Uml::AssociationRole meta_dstLine;
		static ::Uml::AssociationRole meta_dstLine_rev;
		static ::Uml::CompositionChildRole meta_TypeBaseRef_child;
		static ::Uml::CompositionParentRole meta_Block_parent;

	};

	class OutPort :  public Port {
	public:
		OutPort() {}
		OutPort(Udm::ObjectImpl *impl) : Port(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		OutPort(const OutPort &master) : Port(master), MgaObject(master), UDM_OBJECT(master) {}

		static OutPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static OutPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		OutPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<OutPort> Instances() { return Udm::InstantiatedAttr<OutPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<OutPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<OutPort, Pred>(impl); }
		OutPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<OutPort> Derived() { return Udm::DerivedAttr<OutPort>(impl); }
		template <class Pred> Udm::DerivedAttr<OutPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<OutPort, Pred>(impl); }
		Udm::ArchetypeAttr<OutPort> Archetype() const { return Udm::ArchetypeAttr<OutPort>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;

	};

	class StatePort :  public OutPort {
	public:
		StatePort() {}
		StatePort(Udm::ObjectImpl *impl) : OutPort(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		StatePort(const StatePort &master) : OutPort(master), MgaObject(master), UDM_OBJECT(master) {}

		static StatePort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static StatePort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		StatePort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<StatePort> Instances() { return Udm::InstantiatedAttr<StatePort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<StatePort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<StatePort, Pred>(impl); }
		StatePort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<StatePort> Derived() { return Udm::DerivedAttr<StatePort>(impl); }
		template <class Pred> Udm::DerivedAttr<StatePort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<StatePort, Pred>(impl); }
		Udm::ArchetypeAttr<StatePort> Archetype() const { return Udm::ArchetypeAttr<StatePort>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_StatePort(*this); }

		static ::Uml::Class meta;

	};

	class InPort :  public Port {
	public:
		InPort() {}
		InPort(Udm::ObjectImpl *impl) : Port(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		InPort(const InPort &master) : Port(master), MgaObject(master), UDM_OBJECT(master) {}

		static InPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static InPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		InPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<InPort> Instances() { return Udm::InstantiatedAttr<InPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<InPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<InPort, Pred>(impl); }
		InPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<InPort> Derived() { return Udm::DerivedAttr<InPort>(impl); }
		template <class Pred> Udm::DerivedAttr<InPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<InPort, Pred>(impl); }
		Udm::ArchetypeAttr<InPort> Archetype() const { return Udm::ArchetypeAttr<InPort>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;

	};

	class EnablePort :  public InPort {
	public:
		EnablePort() {}
		EnablePort(Udm::ObjectImpl *impl) : InPort(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		EnablePort(const EnablePort &master) : InPort(master), MgaObject(master), UDM_OBJECT(master) {}

		static EnablePort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static EnablePort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		EnablePort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<EnablePort> Instances() { return Udm::InstantiatedAttr<EnablePort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<EnablePort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<EnablePort, Pred>(impl); }
		EnablePort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<EnablePort> Derived() { return Udm::DerivedAttr<EnablePort>(impl); }
		template <class Pred> Udm::DerivedAttr<EnablePort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<EnablePort, Pred>(impl); }
		Udm::ArchetypeAttr<EnablePort> Archetype() const { return Udm::ArchetypeAttr<EnablePort>(impl); }
		Udm::StringAttr StatesWhenEnabling() const { return Udm::StringAttr(impl, meta_StatesWhenEnabling); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_EnablePort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_StatesWhenEnabling;

	};

	class TriggerPort :  public InPort {
	public:
		TriggerPort() {}
		TriggerPort(Udm::ObjectImpl *impl) : InPort(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		TriggerPort(const TriggerPort &master) : InPort(master), MgaObject(master), UDM_OBJECT(master) {}

		static TriggerPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TriggerPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TriggerPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TriggerPort> Instances() { return Udm::InstantiatedAttr<TriggerPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TriggerPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TriggerPort, Pred>(impl); }
		TriggerPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TriggerPort> Derived() { return Udm::DerivedAttr<TriggerPort>(impl); }
		template <class Pred> Udm::DerivedAttr<TriggerPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TriggerPort, Pred>(impl); }
		Udm::ArchetypeAttr<TriggerPort> Archetype() const { return Udm::ArchetypeAttr<TriggerPort>(impl); }
		Udm::StringAttr TriggerType() const { return Udm::StringAttr(impl, meta_TriggerType); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TriggerPort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_TriggerType;

	};

	class ActionPort :  public InPort {
	public:
		ActionPort() {}
		ActionPort(Udm::ObjectImpl *impl) : InPort(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		ActionPort(const ActionPort &master) : InPort(master), MgaObject(master), UDM_OBJECT(master) {}

		static ActionPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ActionPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ActionPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ActionPort> Instances() { return Udm::InstantiatedAttr<ActionPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ActionPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ActionPort, Pred>(impl); }
		ActionPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ActionPort> Derived() { return Udm::DerivedAttr<ActionPort>(impl); }
		template <class Pred> Udm::DerivedAttr<ActionPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ActionPort, Pred>(impl); }
		Udm::ArchetypeAttr<ActionPort> Archetype() const { return Udm::ArchetypeAttr<ActionPort>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_ActionPort(*this); }

		static ::Uml::Class meta;

	};

	class TTBus :  public Bus {
	public:
		TTBus() {}
		TTBus(Udm::ObjectImpl *impl) : Bus(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		TTBus(const TTBus &master) : Bus(master), MgaObject(master), UDM_OBJECT(master) {}

		static TTBus Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TTBus Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TTBus CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TTBus> Instances() { return Udm::InstantiatedAttr<TTBus>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TTBus, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TTBus, Pred>(impl); }
		TTBus CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TTBus> Derived() { return Udm::DerivedAttr<TTBus>(impl); }
		template <class Pred> Udm::DerivedAttr<TTBus, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TTBus, Pred>(impl); }
		Udm::ArchetypeAttr<TTBus> Archetype() const { return Udm::ArchetypeAttr<TTBus>(impl); }
		Udm::StringAttr TTSetupTime() const { return Udm::StringAttr(impl, meta_TTSetupTime); }
		Udm::StringAttr Hyperperiod() const { return Udm::StringAttr(impl, meta_Hyperperiod); }
		Udm::StringAttr SlotSize() const { return Udm::StringAttr(impl, meta_SlotSize); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TTBus(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_TTSetupTime;
		static ::Uml::Attribute meta_Hyperperiod;
		static ::Uml::Attribute meta_SlotSize;

	};

	class OldBus :  public Bus {
	public:
		OldBus() {}
		OldBus(Udm::ObjectImpl *impl) : Bus(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		OldBus(const OldBus &master) : Bus(master), MgaObject(master), UDM_OBJECT(master) {}

		static OldBus Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static OldBus Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		OldBus CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<OldBus> Instances() { return Udm::InstantiatedAttr<OldBus>(impl); }
		template <class Pred> Udm::InstantiatedAttr<OldBus, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<OldBus, Pred>(impl); }
		OldBus CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<OldBus> Derived() { return Udm::DerivedAttr<OldBus>(impl); }
		template <class Pred> Udm::DerivedAttr<OldBus, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<OldBus, Pred>(impl); }
		Udm::ArchetypeAttr<OldBus> Archetype() const { return Udm::ArchetypeAttr<OldBus>(impl); }
		Udm::IntegerAttr FrameSize() const { return Udm::IntegerAttr(impl, meta_FrameSize); }
		Udm::StringAttr Medium() const { return Udm::StringAttr(impl, meta_Medium); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_OldBus(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_FrameSize;
		static ::Uml::Attribute meta_Medium;

	};

	class ModelInfo :  public MgaObject {
	public:
		ModelInfo() {}
		ModelInfo(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ModelInfo(const ModelInfo &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ModelInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ModelInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ModelInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ModelInfo> Instances() { return Udm::InstantiatedAttr<ModelInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ModelInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ModelInfo, Pred>(impl); }
		ModelInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ModelInfo> Derived() { return Udm::DerivedAttr<ModelInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<ModelInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ModelInfo, Pred>(impl); }
		Udm::ArchetypeAttr<ModelInfo> Archetype() const { return Udm::ArchetypeAttr<ModelInfo>(impl); }
		Udm::StringAttr DateTimeStamp() const { return Udm::StringAttr(impl, meta_DateTimeStamp); }
		Udm::StringAttr ModelPath() const { return Udm::StringAttr(impl, meta_ModelPath); }
		Udm::ParentAttr< ::ESMoL::ModelsFolder> ModelsFolder_parent() const { return Udm::ParentAttr< ::ESMoL::ModelsFolder>(impl, meta_ModelsFolder_parent); }
		Udm::ParentAttr< ::ESMoL::ModelsFolder> parent() const { return Udm::ParentAttr< ::ESMoL::ModelsFolder>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_ModelInfo(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_DateTimeStamp;
		static ::Uml::Attribute meta_ModelPath;
		static ::Uml::CompositionParentRole meta_ModelsFolder_parent;

	};

	class NodeRef :  public MgaObject {
	public:
		NodeRef() {}
		NodeRef(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		NodeRef(const NodeRef &master) : MgaObject(master), UDM_OBJECT(master) {}

		static NodeRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static NodeRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		NodeRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<NodeRef> Instances() { return Udm::InstantiatedAttr<NodeRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<NodeRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<NodeRef, Pred>(impl); }
		NodeRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<NodeRef> Derived() { return Udm::DerivedAttr<NodeRef>(impl); }
		template <class Pred> Udm::DerivedAttr<NodeRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<NodeRef, Pred>(impl); }
		Udm::ArchetypeAttr<NodeRef> Archetype() const { return Udm::ArchetypeAttr<NodeRef>(impl); }
		Udm::PointerAttr< ::ESMoL::Node> ref() const { return Udm::PointerAttr< ::ESMoL::Node>(impl, meta_ref); }
		Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::ComponentRef> srcComponentAssignment() const { return Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::ComponentRef>(impl, meta_srcComponentAssignment, meta_srcComponentAssignment_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::ComponentRef, Pred> srcComponentAssignment_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::ComponentRef, Pred>(impl, meta_srcComponentAssignment, meta_srcComponentAssignment_rev); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_NodeRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;
		static ::Uml::AssociationRole meta_srcComponentAssignment;
		static ::Uml::AssociationRole meta_srcComponentAssignment_rev;
		static ::Uml::CompositionParentRole meta_System_parent;

	};

	class CommMapping :  public MgaObject {
	public:
		CommMapping() {}
		CommMapping(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		CommMapping(const CommMapping &master) : MgaObject(master), UDM_OBJECT(master) {}

		static CommMapping Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static CommMapping Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		CommMapping CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<CommMapping> Instances() { return Udm::InstantiatedAttr<CommMapping>(impl); }
		template <class Pred> Udm::InstantiatedAttr<CommMapping, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<CommMapping, Pred>(impl); }
		CommMapping CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<CommMapping> Derived() { return Udm::DerivedAttr<CommMapping>(impl); }
		template <class Pred> Udm::DerivedAttr<CommMapping, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<CommMapping, Pred>(impl); }
		Udm::ArchetypeAttr<CommMapping> Archetype() const { return Udm::ArchetypeAttr<CommMapping>(impl); }
		Udm::PointerAttr< ::ESMoL::ComponentRef> dstCommMapping__rp_helper() const { return Udm::PointerAttr< ::ESMoL::ComponentRef>(impl, meta_dstCommMapping__rp_helper); }
		Udm::PointerAttr< ::ESMoL::ComponentRef> srcCommMapping__rp_helper() const { return Udm::PointerAttr< ::ESMoL::ComponentRef>(impl, meta_srcCommMapping__rp_helper); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::CommMapping_Members_Base> dstCommMapping_end() const { return Udm::AssocEndAttr< ::ESMoL::CommMapping_Members_Base>(impl, meta_dstCommMapping_end_); }
		Udm::AssocEndAttr< ::ESMoL::CommMapping_Members_Base> srcCommMapping_end() const { return Udm::AssocEndAttr< ::ESMoL::CommMapping_Members_Base>(impl, meta_srcCommMapping_end_); }
		void Accept(Visitor &v) { v.Visit_CommMapping(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstCommMapping__rp_helper;
		static ::Uml::AssociationRole meta_srcCommMapping__rp_helper;
		static ::Uml::CompositionParentRole meta_System_parent;
		static ::Uml::AssociationRole meta_dstCommMapping_end_;
		static ::Uml::AssociationRole meta_srcCommMapping_end_;

	};

	class Dependency :  public MgaObject {
	public:
		Dependency() {}
		Dependency(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Dependency(const Dependency &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Dependency Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Dependency Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Dependency CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Dependency> Instances() { return Udm::InstantiatedAttr<Dependency>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Dependency, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Dependency, Pred>(impl); }
		Dependency CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Dependency> Derived() { return Udm::DerivedAttr<Dependency>(impl); }
		template <class Pred> Udm::DerivedAttr<Dependency, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Dependency, Pred>(impl); }
		Udm::ArchetypeAttr<Dependency> Archetype() const { return Udm::ArchetypeAttr<Dependency>(impl); }
		Udm::PointerAttr< ::ESMoL::ComponentRef> dstDependency__rp_helper() const { return Udm::PointerAttr< ::ESMoL::ComponentRef>(impl, meta_dstDependency__rp_helper); }
		Udm::PointerAttr< ::ESMoL::ComponentRef> srcDependency__rp_helper() const { return Udm::PointerAttr< ::ESMoL::ComponentRef>(impl, meta_srcDependency__rp_helper); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::MessageRef> srcDependency_end() const { return Udm::AssocEndAttr< ::ESMoL::MessageRef>(impl, meta_srcDependency_end_); }
		Udm::AssocEndAttr< ::ESMoL::MessageRef> dstDependency_end() const { return Udm::AssocEndAttr< ::ESMoL::MessageRef>(impl, meta_dstDependency_end_); }
		void Accept(Visitor &v) { v.Visit_Dependency(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstDependency__rp_helper;
		static ::Uml::AssociationRole meta_srcDependency__rp_helper;
		static ::Uml::CompositionParentRole meta_System_parent;
		static ::Uml::AssociationRole meta_srcDependency_end_;
		static ::Uml::AssociationRole meta_dstDependency_end_;

	};

	class ComponentAssignment :  public MgaObject {
	public:
		ComponentAssignment() {}
		ComponentAssignment(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ComponentAssignment(const ComponentAssignment &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ComponentAssignment Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ComponentAssignment Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ComponentAssignment CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ComponentAssignment> Instances() { return Udm::InstantiatedAttr<ComponentAssignment>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ComponentAssignment, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ComponentAssignment, Pred>(impl); }
		ComponentAssignment CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ComponentAssignment> Derived() { return Udm::DerivedAttr<ComponentAssignment>(impl); }
		template <class Pred> Udm::DerivedAttr<ComponentAssignment, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ComponentAssignment, Pred>(impl); }
		Udm::ArchetypeAttr<ComponentAssignment> Archetype() const { return Udm::ArchetypeAttr<ComponentAssignment>(impl); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::NodeRef> dstComponentAssignment_end() const { return Udm::AssocEndAttr< ::ESMoL::NodeRef>(impl, meta_dstComponentAssignment_end_); }
		Udm::AssocEndAttr< ::ESMoL::ComponentRef> srcComponentAssignment_end() const { return Udm::AssocEndAttr< ::ESMoL::ComponentRef>(impl, meta_srcComponentAssignment_end_); }
		void Accept(Visitor &v) { v.Visit_ComponentAssignment(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_System_parent;
		static ::Uml::AssociationRole meta_dstComponentAssignment_end_;
		static ::Uml::AssociationRole meta_srcComponentAssignment_end_;

	};

	class System :  public MgaObject {
	public:
		System() {}
		System(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		System(const System &master) : MgaObject(master), UDM_OBJECT(master) {}

		static System Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static System Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		System CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<System> Instances() { return Udm::InstantiatedAttr<System>(impl); }
		template <class Pred> Udm::InstantiatedAttr<System, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<System, Pred>(impl); }
		System CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<System> Derived() { return Udm::DerivedAttr<System>(impl); }
		template <class Pred> Udm::DerivedAttr<System, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<System, Pred>(impl); }
		Udm::ArchetypeAttr<System> Archetype() const { return Udm::ArchetypeAttr<System>(impl); }
		Udm::ChildrenAttr< ::ESMoL::NodeRef> NodeRef_children() const { return Udm::ChildrenAttr< ::ESMoL::NodeRef>(impl, meta_NodeRef_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::NodeRef, Pred> NodeRef_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::NodeRef, Pred>(impl, meta_NodeRef_children); }
		Udm::ChildrenAttr< ::ESMoL::ComponentRef> ComponentRef_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef>(impl, meta_ComponentRef_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentRef, Pred> ComponentRef_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef, Pred>(impl, meta_ComponentRef_children); }
		Udm::ChildrenAttr< ::ESMoL::CommMapping> CommMapping_children() const { return Udm::ChildrenAttr< ::ESMoL::CommMapping>(impl, meta_CommMapping_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CommMapping, Pred> CommMapping_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CommMapping, Pred>(impl, meta_CommMapping_children); }
		Udm::ChildrenAttr< ::ESMoL::Dependency> Dependency_children() const { return Udm::ChildrenAttr< ::ESMoL::Dependency>(impl, meta_Dependency_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Dependency, Pred> Dependency_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Dependency, Pred>(impl, meta_Dependency_children); }
		Udm::ChildrenAttr< ::ESMoL::ComponentAssignment> ComponentAssignment_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentAssignment>(impl, meta_ComponentAssignment_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentAssignment, Pred> ComponentAssignment_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentAssignment, Pred>(impl, meta_ComponentAssignment_children); }
		Udm::ChildrenAttr< ::ESMoL::ExecutionInfo> ExecutionInfo_children() const { return Udm::ChildrenAttr< ::ESMoL::ExecutionInfo>(impl, meta_ExecutionInfo_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ExecutionInfo, Pred> ExecutionInfo_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ExecutionInfo, Pred>(impl, meta_ExecutionInfo_children); }
		Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment> ExecutionAssignment_children() const { return Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment>(impl, meta_ExecutionAssignment_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment, Pred> ExecutionAssignment_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment, Pred>(impl, meta_ExecutionAssignment_children); }
		Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base, Pred> ComponentRef_RefersTo_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::NodeRef> NodeRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::NodeRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::NodeRef, Pred> NodeRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::NodeRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::CommMapping> CommMapping_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CommMapping>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CommMapping, Pred> CommMapping_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CommMapping, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Dependency> Dependency_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Dependency>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Dependency, Pred> Dependency_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Dependency, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ComponentAssignment> ComponentAssignment_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentAssignment>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentAssignment, Pred> ComponentAssignment_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentAssignment, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ComponentRef> ComponentRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentRef, Pred> ComponentRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::AsyncPeriodicExecInfo> AsyncPeriodicExecInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::AsyncPeriodicExecInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::AsyncPeriodicExecInfo, Pred> AsyncPeriodicExecInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::AsyncPeriodicExecInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TTExecInfo> TTExecInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TTExecInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TTExecInfo, Pred> TTExecInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TTExecInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ExecutionInfo> ExecutionInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ExecutionInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ExecutionInfo, Pred> ExecutionInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ExecutionInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment> ExecutionAssignment_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment, Pred> ExecutionAssignment_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ExecutionAssignment, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::SporadicExecInfo> SporadicExecInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::SporadicExecInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::SporadicExecInfo, Pred> SporadicExecInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::SporadicExecInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Executable> Executable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Executable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Executable, Pred> Executable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Executable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::PeriodicExecInfo> PeriodicExecInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::PeriodicExecInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::PeriodicExecInfo, Pred> PeriodicExecInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::PeriodicExecInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::AperiodicExecInfo> AperiodicExecInfo_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::AperiodicExecInfo>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::AperiodicExecInfo, Pred> AperiodicExecInfo_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::AperiodicExecInfo, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::DeploymentLibrary> DeploymentLibrary_parent() const { return Udm::ParentAttr< ::ESMoL::DeploymentLibrary>(impl, meta_DeploymentLibrary_parent); }
		Udm::ParentAttr< ::ESMoL::DesignFolder> DesignFolder_parent() const { return Udm::ParentAttr< ::ESMoL::DesignFolder>(impl, meta_DesignFolder_parent); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_System(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionChildRole meta_NodeRef_children;
		static ::Uml::CompositionChildRole meta_ComponentRef_children;
		static ::Uml::CompositionChildRole meta_CommMapping_children;
		static ::Uml::CompositionChildRole meta_Dependency_children;
		static ::Uml::CompositionChildRole meta_ComponentAssignment_children;
		static ::Uml::CompositionChildRole meta_ExecutionInfo_children;
		static ::Uml::CompositionChildRole meta_ExecutionAssignment_children;
		static ::Uml::CompositionParentRole meta_DeploymentLibrary_parent;
		static ::Uml::CompositionParentRole meta_DesignFolder_parent;

	};

	class ExecutionContext :  public MgaObject {
	public:
		ExecutionContext() {}
		ExecutionContext(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ExecutionContext(const ExecutionContext &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ExecutionContext Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ExecutionContext Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ExecutionContext CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ExecutionContext> Instances() { return Udm::InstantiatedAttr<ExecutionContext>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ExecutionContext, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ExecutionContext, Pred>(impl); }
		ExecutionContext CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ExecutionContext> Derived() { return Udm::DerivedAttr<ExecutionContext>(impl); }
		template <class Pred> Udm::DerivedAttr<ExecutionContext, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ExecutionContext, Pred>(impl); }
		Udm::ArchetypeAttr<ExecutionContext> Archetype() const { return Udm::ArchetypeAttr<ExecutionContext>(impl); }
		Udm::ParentAttr< ::ESMoL::HWElement> HWElement_parent() const { return Udm::ParentAttr< ::ESMoL::HWElement>(impl, meta_HWElement_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_HWElement_parent;

	};

	class TTExecContext :  public ExecutionContext {
	public:
		TTExecContext() {}
		TTExecContext(Udm::ObjectImpl *impl) : ExecutionContext(impl), UDM_OBJECT(impl) {}
		TTExecContext(const TTExecContext &master) : ExecutionContext(master), UDM_OBJECT(master) {}

		static TTExecContext Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TTExecContext Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TTExecContext CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TTExecContext> Instances() { return Udm::InstantiatedAttr<TTExecContext>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TTExecContext, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TTExecContext, Pred>(impl); }
		TTExecContext CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TTExecContext> Derived() { return Udm::DerivedAttr<TTExecContext>(impl); }
		template <class Pred> Udm::DerivedAttr<TTExecContext, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TTExecContext, Pred>(impl); }
		Udm::ArchetypeAttr<TTExecContext> Archetype() const { return Udm::ArchetypeAttr<TTExecContext>(impl); }
		Udm::StringAttr Hyperperiod() const { return Udm::StringAttr(impl, meta_Hyperperiod); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TTExecContext(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Hyperperiod;

	};

	class ExecutionInfo :  public MgaObject {
	public:
		ExecutionInfo() {}
		ExecutionInfo(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ExecutionInfo(const ExecutionInfo &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ExecutionInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ExecutionInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ExecutionInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ExecutionInfo> Instances() { return Udm::InstantiatedAttr<ExecutionInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ExecutionInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ExecutionInfo, Pred>(impl); }
		ExecutionInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ExecutionInfo> Derived() { return Udm::DerivedAttr<ExecutionInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<ExecutionInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ExecutionInfo, Pred>(impl); }
		Udm::ArchetypeAttr<ExecutionInfo> Archetype() const { return Udm::ArchetypeAttr<ExecutionInfo>(impl); }
		Udm::StringAttr WCDuration() const { return Udm::StringAttr(impl, meta_WCDuration); }
		Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::Executable> dstExecutionAssignment() const { return Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::Executable>(impl, meta_dstExecutionAssignment, meta_dstExecutionAssignment_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::Executable, Pred> dstExecutionAssignment_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::Executable, Pred>(impl, meta_dstExecutionAssignment, meta_dstExecutionAssignment_rev); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_WCDuration;
		static ::Uml::AssociationRole meta_dstExecutionAssignment;
		static ::Uml::AssociationRole meta_dstExecutionAssignment_rev;
		static ::Uml::CompositionParentRole meta_System_parent;

	};

	class ExecutionAssignment :  public MgaObject {
	public:
		ExecutionAssignment() {}
		ExecutionAssignment(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ExecutionAssignment(const ExecutionAssignment &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ExecutionAssignment Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ExecutionAssignment Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ExecutionAssignment CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ExecutionAssignment> Instances() { return Udm::InstantiatedAttr<ExecutionAssignment>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ExecutionAssignment, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ExecutionAssignment, Pred>(impl); }
		ExecutionAssignment CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ExecutionAssignment> Derived() { return Udm::DerivedAttr<ExecutionAssignment>(impl); }
		template <class Pred> Udm::DerivedAttr<ExecutionAssignment, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ExecutionAssignment, Pred>(impl); }
		Udm::ArchetypeAttr<ExecutionAssignment> Archetype() const { return Udm::ArchetypeAttr<ExecutionAssignment>(impl); }
		Udm::PointerAttr< ::ESMoL::ComponentRef> dstExecutionAssignment__rp_helper() const { return Udm::PointerAttr< ::ESMoL::ComponentRef>(impl, meta_dstExecutionAssignment__rp_helper); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::Executable> dstExecutionAssignment_end() const { return Udm::AssocEndAttr< ::ESMoL::Executable>(impl, meta_dstExecutionAssignment_end_); }
		Udm::AssocEndAttr< ::ESMoL::ExecutionInfo> srcExecutionAssignment_end() const { return Udm::AssocEndAttr< ::ESMoL::ExecutionInfo>(impl, meta_srcExecutionAssignment_end_); }
		void Accept(Visitor &v) { v.Visit_ExecutionAssignment(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstExecutionAssignment__rp_helper;
		static ::Uml::CompositionParentRole meta_System_parent;
		static ::Uml::AssociationRole meta_dstExecutionAssignment_end_;
		static ::Uml::AssociationRole meta_srcExecutionAssignment_end_;

	};

	class Executable :  virtual  public MgaObject {
	public:
		Executable() {}
		Executable(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Executable(const Executable &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Executable Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Executable Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Executable CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Executable> Instances() { return Udm::InstantiatedAttr<Executable>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Executable, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Executable, Pred>(impl); }
		Executable CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Executable> Derived() { return Udm::DerivedAttr<Executable>(impl); }
		template <class Pred> Udm::DerivedAttr<Executable, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Executable, Pred>(impl); }
		Udm::ArchetypeAttr<Executable> Archetype() const { return Udm::ArchetypeAttr<Executable>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::ExecutionInfo> srcExecutionAssignment() const { return Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::ExecutionInfo>(impl, meta_srcExecutionAssignment, meta_srcExecutionAssignment_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::ExecutionInfo, Pred> srcExecutionAssignment_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::ExecutionAssignment, ::ESMoL::ExecutionInfo, Pred>(impl, meta_srcExecutionAssignment, meta_srcExecutionAssignment_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcExecutionAssignment;
		static ::Uml::AssociationRole meta_srcExecutionAssignment_rev;

	};

	class Channel :  public CommMapping_Members_Base,  public Connectable,  public Executable {
	public:
		Channel() {}
		Channel(Udm::ObjectImpl *impl) : CommMapping_Members_Base(impl),Connectable(impl),Executable(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Channel(const Channel &master) : CommMapping_Members_Base(master),Connectable(master),Executable(master), MgaObject(master), UDM_OBJECT(master) {}

		static Channel Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Channel Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Channel CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Channel> Instances() { return Udm::InstantiatedAttr<Channel>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Channel, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Channel, Pred>(impl); }
		Channel CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Channel> Derived() { return Udm::DerivedAttr<Channel>(impl); }
		template <class Pred> Udm::DerivedAttr<Channel, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Channel, Pred>(impl); }
		Udm::ArchetypeAttr<Channel> Archetype() const { return Udm::ArchetypeAttr<Channel>(impl); }
		Udm::StringAttr Configuration() const { return Udm::StringAttr(impl, meta_Configuration); }
		Udm::ParentAttr< ::ESMoL::HardwareUnit> HardwareUnit_parent() const { return Udm::ParentAttr< ::ESMoL::HardwareUnit>(impl, meta_HardwareUnit_parent); }
		Udm::ParentAttr< ::ESMoL::Node> Node_parent() const { return Udm::ParentAttr< ::ESMoL::Node>(impl, meta_Node_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Configuration;
		static ::Uml::CompositionParentRole meta_HardwareUnit_parent;
		static ::Uml::CompositionParentRole meta_Node_parent;

	};

	class IChan :  public Channel {
	public:
		IChan() {}
		IChan(Udm::ObjectImpl *impl) : Channel(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		IChan(const IChan &master) : Channel(master), MgaObject(master), UDM_OBJECT(master) {}

		static IChan Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static IChan Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		IChan CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<IChan> Instances() { return Udm::InstantiatedAttr<IChan>(impl); }
		template <class Pred> Udm::InstantiatedAttr<IChan, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<IChan, Pred>(impl); }
		IChan CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<IChan> Derived() { return Udm::DerivedAttr<IChan>(impl); }
		template <class Pred> Udm::DerivedAttr<IChan, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<IChan, Pred>(impl); }
		Udm::ArchetypeAttr<IChan> Archetype() const { return Udm::ArchetypeAttr<IChan>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IODevice> srcAcquisitionConnection() const { return Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IODevice>(impl, meta_srcAcquisitionConnection, meta_srcAcquisitionConnection_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IODevice, Pred> srcAcquisitionConnection_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::AcquisitionConnection, ::ESMoL::IODevice, Pred>(impl, meta_srcAcquisitionConnection, meta_srcAcquisitionConnection_rev); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_IChan(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcAcquisitionConnection;
		static ::Uml::AssociationRole meta_srcAcquisitionConnection_rev;

	};

	class OChan :  public Channel {
	public:
		OChan() {}
		OChan(Udm::ObjectImpl *impl) : Channel(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		OChan(const OChan &master) : Channel(master), MgaObject(master), UDM_OBJECT(master) {}

		static OChan Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static OChan Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		OChan CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<OChan> Instances() { return Udm::InstantiatedAttr<OChan>(impl); }
		template <class Pred> Udm::InstantiatedAttr<OChan, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<OChan, Pred>(impl); }
		OChan CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<OChan> Derived() { return Udm::DerivedAttr<OChan>(impl); }
		template <class Pred> Udm::DerivedAttr<OChan, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<OChan, Pred>(impl); }
		Udm::ArchetypeAttr<OChan> Archetype() const { return Udm::ArchetypeAttr<OChan>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::IODevice> dstActuationConnection() const { return Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::IODevice>(impl, meta_dstActuationConnection, meta_dstActuationConnection_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::IODevice, Pred> dstActuationConnection_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::ActuationConnection, ::ESMoL::IODevice, Pred>(impl, meta_dstActuationConnection, meta_dstActuationConnection_rev); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_OChan(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstActuationConnection;
		static ::Uml::AssociationRole meta_dstActuationConnection_rev;

	};

	class BChan :  public Channel {
	public:
		BChan() {}
		BChan(Udm::ObjectImpl *impl) : Channel(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		BChan(const BChan &master) : Channel(master), MgaObject(master), UDM_OBJECT(master) {}

		static BChan Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static BChan Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		BChan CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<BChan> Instances() { return Udm::InstantiatedAttr<BChan>(impl); }
		template <class Pred> Udm::InstantiatedAttr<BChan, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<BChan, Pred>(impl); }
		BChan CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<BChan> Derived() { return Udm::DerivedAttr<BChan>(impl); }
		template <class Pred> Udm::DerivedAttr<BChan, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<BChan, Pred>(impl); }
		Udm::ArchetypeAttr<BChan> Archetype() const { return Udm::ArchetypeAttr<BChan>(impl); }
		Udm::ParentAttr< ::ESMoL::Router> Router_parent() const { return Udm::ParentAttr< ::ESMoL::Router>(impl, meta_Router_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_BChan(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionParentRole meta_Router_parent;

	};

	class ComponentRef :  public ComponentRef_RefersTo_Base,  public Executable {
	public:
		ComponentRef() {}
		ComponentRef(Udm::ObjectImpl *impl) : ComponentRef_RefersTo_Base(impl),Executable(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		ComponentRef(const ComponentRef &master) : ComponentRef_RefersTo_Base(master),Executable(master), MgaObject(master), UDM_OBJECT(master) {}

		static ComponentRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ComponentRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ComponentRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ComponentRef> Instances() { return Udm::InstantiatedAttr<ComponentRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ComponentRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ComponentRef, Pred>(impl); }
		ComponentRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ComponentRef> Derived() { return Udm::DerivedAttr<ComponentRef>(impl); }
		template <class Pred> Udm::DerivedAttr<ComponentRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ComponentRef, Pred>(impl); }
		Udm::ArchetypeAttr<ComponentRef> Archetype() const { return Udm::ArchetypeAttr<ComponentRef>(impl); }
		Udm::PointerAttr< ::ESMoL::ComponentRef_RefersTo_Base> ref() const { return Udm::PointerAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, meta_ref); }
		Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::NodeRef> dstComponentAssignment() const { return Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::NodeRef>(impl, meta_dstComponentAssignment, meta_dstComponentAssignment_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::NodeRef, Pred> dstComponentAssignment_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::ComponentAssignment, ::ESMoL::NodeRef, Pred>(impl, meta_dstComponentAssignment, meta_dstComponentAssignment_rev); }
		Udm::PointerAttr< ::ESMoL::CommMapping> cms() const { return Udm::PointerAttr< ::ESMoL::CommMapping>(impl, meta_cms); }
		Udm::PointerAttr< ::ESMoL::CommMapping> cmd() const { return Udm::PointerAttr< ::ESMoL::CommMapping>(impl, meta_cmd); }
		Udm::PointerAttr< ::ESMoL::Dependency> dps() const { return Udm::PointerAttr< ::ESMoL::Dependency>(impl, meta_dps); }
		Udm::PointerAttr< ::ESMoL::Dependency> dpd() const { return Udm::PointerAttr< ::ESMoL::Dependency>(impl, meta_dpd); }
		Udm::PointerAttr< ::ESMoL::ExecutionAssignment> eas() const { return Udm::PointerAttr< ::ESMoL::ExecutionAssignment>(impl, meta_eas); }
		Udm::ParentAttr< ::ESMoL::System> System_parent() const { return Udm::ParentAttr< ::ESMoL::System>(impl, meta_System_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_ComponentRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;
		static ::Uml::AssociationRole meta_dstComponentAssignment;
		static ::Uml::AssociationRole meta_dstComponentAssignment_rev;
		static ::Uml::AssociationRole meta_cms;
		static ::Uml::AssociationRole meta_cmd;
		static ::Uml::AssociationRole meta_dps;
		static ::Uml::AssociationRole meta_dpd;
		static ::Uml::AssociationRole meta_eas;
		static ::Uml::CompositionParentRole meta_System_parent;

	};

	class PeriodicExecInfo :  public ExecutionInfo {
	public:
		PeriodicExecInfo() {}
		PeriodicExecInfo(Udm::ObjectImpl *impl) : ExecutionInfo(impl), UDM_OBJECT(impl) {}
		PeriodicExecInfo(const PeriodicExecInfo &master) : ExecutionInfo(master), UDM_OBJECT(master) {}

		static PeriodicExecInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static PeriodicExecInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		PeriodicExecInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<PeriodicExecInfo> Instances() { return Udm::InstantiatedAttr<PeriodicExecInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<PeriodicExecInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<PeriodicExecInfo, Pred>(impl); }
		PeriodicExecInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<PeriodicExecInfo> Derived() { return Udm::DerivedAttr<PeriodicExecInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<PeriodicExecInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<PeriodicExecInfo, Pred>(impl); }
		Udm::ArchetypeAttr<PeriodicExecInfo> Archetype() const { return Udm::ArchetypeAttr<PeriodicExecInfo>(impl); }
		Udm::StringAttr ExecPeriod() const { return Udm::StringAttr(impl, meta_ExecPeriod); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_ExecPeriod;

	};

	class AsyncPeriodicExecInfo :  public PeriodicExecInfo {
	public:
		AsyncPeriodicExecInfo() {}
		AsyncPeriodicExecInfo(Udm::ObjectImpl *impl) : PeriodicExecInfo(impl), UDM_OBJECT(impl) {}
		AsyncPeriodicExecInfo(const AsyncPeriodicExecInfo &master) : PeriodicExecInfo(master), UDM_OBJECT(master) {}

		static AsyncPeriodicExecInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static AsyncPeriodicExecInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		AsyncPeriodicExecInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<AsyncPeriodicExecInfo> Instances() { return Udm::InstantiatedAttr<AsyncPeriodicExecInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<AsyncPeriodicExecInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<AsyncPeriodicExecInfo, Pred>(impl); }
		AsyncPeriodicExecInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<AsyncPeriodicExecInfo> Derived() { return Udm::DerivedAttr<AsyncPeriodicExecInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<AsyncPeriodicExecInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<AsyncPeriodicExecInfo, Pred>(impl); }
		Udm::ArchetypeAttr<AsyncPeriodicExecInfo> Archetype() const { return Udm::ArchetypeAttr<AsyncPeriodicExecInfo>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_AsyncPeriodicExecInfo(*this); }

		static ::Uml::Class meta;

	};

	class TTExecInfo :  public PeriodicExecInfo {
	public:
		TTExecInfo() {}
		TTExecInfo(Udm::ObjectImpl *impl) : PeriodicExecInfo(impl), UDM_OBJECT(impl) {}
		TTExecInfo(const TTExecInfo &master) : PeriodicExecInfo(master), UDM_OBJECT(master) {}

		static TTExecInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TTExecInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TTExecInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TTExecInfo> Instances() { return Udm::InstantiatedAttr<TTExecInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TTExecInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TTExecInfo, Pred>(impl); }
		TTExecInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TTExecInfo> Derived() { return Udm::DerivedAttr<TTExecInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<TTExecInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TTExecInfo, Pred>(impl); }
		Udm::ArchetypeAttr<TTExecInfo> Archetype() const { return Udm::ArchetypeAttr<TTExecInfo>(impl); }
		Udm::StringAttr TTSchedule() const { return Udm::StringAttr(impl, meta_TTSchedule); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TTExecInfo(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_TTSchedule;

	};

	class AperiodicExecInfo :  public ExecutionInfo {
	public:
		AperiodicExecInfo() {}
		AperiodicExecInfo(Udm::ObjectImpl *impl) : ExecutionInfo(impl), UDM_OBJECT(impl) {}
		AperiodicExecInfo(const AperiodicExecInfo &master) : ExecutionInfo(master), UDM_OBJECT(master) {}

		static AperiodicExecInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static AperiodicExecInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		AperiodicExecInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<AperiodicExecInfo> Instances() { return Udm::InstantiatedAttr<AperiodicExecInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<AperiodicExecInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<AperiodicExecInfo, Pred>(impl); }
		AperiodicExecInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<AperiodicExecInfo> Derived() { return Udm::DerivedAttr<AperiodicExecInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<AperiodicExecInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<AperiodicExecInfo, Pred>(impl); }
		Udm::ArchetypeAttr<AperiodicExecInfo> Archetype() const { return Udm::ArchetypeAttr<AperiodicExecInfo>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;

	};

	class SporadicExecInfo :  public AperiodicExecInfo {
	public:
		SporadicExecInfo() {}
		SporadicExecInfo(Udm::ObjectImpl *impl) : AperiodicExecInfo(impl), UDM_OBJECT(impl) {}
		SporadicExecInfo(const SporadicExecInfo &master) : AperiodicExecInfo(master), UDM_OBJECT(master) {}

		static SporadicExecInfo Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static SporadicExecInfo Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		SporadicExecInfo CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<SporadicExecInfo> Instances() { return Udm::InstantiatedAttr<SporadicExecInfo>(impl); }
		template <class Pred> Udm::InstantiatedAttr<SporadicExecInfo, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SporadicExecInfo, Pred>(impl); }
		SporadicExecInfo CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<SporadicExecInfo> Derived() { return Udm::DerivedAttr<SporadicExecInfo>(impl); }
		template <class Pred> Udm::DerivedAttr<SporadicExecInfo, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SporadicExecInfo, Pred>(impl); }
		Udm::ArchetypeAttr<SporadicExecInfo> Archetype() const { return Udm::ArchetypeAttr<SporadicExecInfo>(impl); }
		Udm::StringAttr MinimumPeriod() const { return Udm::StringAttr(impl, meta_MinimumPeriod); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_SporadicExecInfo(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_MinimumPeriod;

	};

	class SystemTypes :  public MgaObject {
	public:
		SystemTypes() {}
		SystemTypes(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		SystemTypes(const SystemTypes &master) : MgaObject(master), UDM_OBJECT(master) {}

		static SystemTypes Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static SystemTypes Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		SystemTypes CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<SystemTypes> Instances() { return Udm::InstantiatedAttr<SystemTypes>(impl); }
		template <class Pred> Udm::InstantiatedAttr<SystemTypes, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SystemTypes, Pred>(impl); }
		SystemTypes CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<SystemTypes> Derived() { return Udm::DerivedAttr<SystemTypes>(impl); }
		template <class Pred> Udm::DerivedAttr<SystemTypes, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SystemTypes, Pred>(impl); }
		Udm::ArchetypeAttr<SystemTypes> Archetype() const { return Udm::ArchetypeAttr<SystemTypes>(impl); }
		Udm::ChildrenAttr< ::ESMoL::Component> Component_children() const { return Udm::ChildrenAttr< ::ESMoL::Component>(impl, meta_Component_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Component, Pred> Component_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Component, Pred>(impl, meta_Component_children); }
		Udm::ChildrenAttr< ::ESMoL::Message> Message_children() const { return Udm::ChildrenAttr< ::ESMoL::Message>(impl, meta_Message_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Message, Pred> Message_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Message, Pred>(impl, meta_Message_children); }
		Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base, Pred> ComponentRef_RefersTo_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentRef_RefersTo_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base> MessageRef_RefersTo_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base, Pred> MessageRef_RefersTo_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Message> Message_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Message>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Message, Pred> Message_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Message, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Component> Component_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Component>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Component, Pred> Component_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Component, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::ArchitectureLibrary> ArchitectureLibrary_parent() const { return Udm::ParentAttr< ::ESMoL::ArchitectureLibrary>(impl, meta_ArchitectureLibrary_parent); }
		Udm::ParentAttr< ::ESMoL::DesignFolder> DesignFolder_parent() const { return Udm::ParentAttr< ::ESMoL::DesignFolder>(impl, meta_DesignFolder_parent); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_SystemTypes(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionChildRole meta_Component_children;
		static ::Uml::CompositionChildRole meta_Message_children;
		static ::Uml::CompositionParentRole meta_ArchitectureLibrary_parent;
		static ::Uml::CompositionParentRole meta_DesignFolder_parent;

	};

	class Connector :  public MgaObject {
	public:
		Connector() {}
		Connector(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Connector(const Connector &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Connector Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Connector Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Connector CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Connector> Instances() { return Udm::InstantiatedAttr<Connector>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Connector, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Connector, Pred>(impl); }
		Connector CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Connector> Derived() { return Udm::DerivedAttr<Connector>(impl); }
		template <class Pred> Udm::DerivedAttr<Connector, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Connector, Pred>(impl); }
		Udm::ArchetypeAttr<Connector> Archetype() const { return Udm::ArchetypeAttr<Connector>(impl); }
		Udm::StringAttr ConnectionType() const { return Udm::StringAttr(impl, meta_ConnectionType); }
		Udm::PointerAttr< ::ESMoL::MessageRef> dstConnector__rp_helper() const { return Udm::PointerAttr< ::ESMoL::MessageRef>(impl, meta_dstConnector__rp_helper); }
		Udm::PointerAttr< ::ESMoL::MessageRef> srcConnector__rp_helper() const { return Udm::PointerAttr< ::ESMoL::MessageRef>(impl, meta_srcConnector__rp_helper); }
		Udm::ParentAttr< ::ESMoL::Component> Component_parent() const { return Udm::ParentAttr< ::ESMoL::Component>(impl, meta_Component_parent); }
		Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_parent() const { return Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLPARENTROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> MgaObject_parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::Input> dstConnector_end() const { return Udm::AssocEndAttr< ::ESMoL::Input>(impl, meta_dstConnector_end_); }
		Udm::AssocEndAttr< ::ESMoL::Output> srcConnector_end() const { return Udm::AssocEndAttr< ::ESMoL::Output>(impl, meta_srcConnector_end_); }
		void Accept(Visitor &v) { v.Visit_Connector(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_ConnectionType;
		static ::Uml::AssociationRole meta_dstConnector__rp_helper;
		static ::Uml::AssociationRole meta_srcConnector__rp_helper;
		static ::Uml::CompositionParentRole meta_Component_parent;
		static ::Uml::AssociationRole meta_dstConnector_end_;
		static ::Uml::AssociationRole meta_srcConnector_end_;

	};

	class Message :  public MessageRef_RefersTo_Base,  public MgaObject {
	public:
		Message() {}
		Message(Udm::ObjectImpl *impl) : MessageRef_RefersTo_Base(impl),MgaObject(impl), UDM_OBJECT(impl) {}
		Message(const Message &master) : MessageRef_RefersTo_Base(master),MgaObject(master), UDM_OBJECT(master) {}

		static Message Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Message Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Message CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Message> Instances() { return Udm::InstantiatedAttr<Message>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Message, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Message, Pred>(impl); }
		Message CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Message> Derived() { return Udm::DerivedAttr<Message>(impl); }
		template <class Pred> Udm::DerivedAttr<Message, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Message, Pred>(impl); }
		Udm::ArchetypeAttr<Message> Archetype() const { return Udm::ArchetypeAttr<Message>(impl); }
		Udm::StringAttr MsgMetaData() const { return Udm::StringAttr(impl, meta_MsgMetaData); }
		Udm::StringAttr MsgSize() const { return Udm::StringAttr(impl, meta_MsgSize); }
		Udm::ChildrenAttr< ::ESMoL::MsgPort> MsgPort_children() const { return Udm::ChildrenAttr< ::ESMoL::MsgPort>(impl, meta_MsgPort_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MsgPort, Pred> MsgPort_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MsgPort, Pred>(impl, meta_MsgPort_children); }
		Udm::ChildrenAttr< ::ESMoL::IOPortExp> IOPortExp_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::IOPortExp>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::IOPortExp, Pred> IOPortExp_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::IOPortExp, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MsgPort> MsgPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MsgPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MsgPort, Pred> MsgPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MsgPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Output> Output_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Output>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Output, Pred> Output_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Output, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Input> Input_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Input>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Input, Pred> Input_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Input, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::SystemTypes> SystemTypes_parent() const { return Udm::ParentAttr< ::ESMoL::SystemTypes>(impl, meta_SystemTypes_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Message(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_MsgMetaData;
		static ::Uml::Attribute meta_MsgSize;
		static ::Uml::CompositionChildRole meta_MsgPort_children;
		static ::Uml::CompositionParentRole meta_SystemTypes_parent;

	};

	class Component :  public ComponentRef_RefersTo_Base,  public MgaObject {
	public:
		Component() {}
		Component(Udm::ObjectImpl *impl) : ComponentRef_RefersTo_Base(impl),MgaObject(impl), UDM_OBJECT(impl) {}
		Component(const Component &master) : ComponentRef_RefersTo_Base(master),MgaObject(master), UDM_OBJECT(master) {}

		static Component Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Component Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Component CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Component> Instances() { return Udm::InstantiatedAttr<Component>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Component, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Component, Pred>(impl); }
		Component CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Component> Derived() { return Udm::DerivedAttr<Component>(impl); }
		template <class Pred> Udm::DerivedAttr<Component, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Component, Pred>(impl); }
		Udm::ArchetypeAttr<Component> Archetype() const { return Udm::ArchetypeAttr<Component>(impl); }
		Udm::AssocAttr< ::ESMoL::TaskRef> referedbyTaskRef() const { return Udm::AssocAttr< ::ESMoL::TaskRef>(impl, meta_referedbyTaskRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::TaskRef, Pred> referedbyTaskRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::TaskRef, Pred>(impl, meta_referedbyTaskRef); }
		Udm::ChildrenAttr< ::ESMoL::ComponentBase> ComponentBase_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentBase>(impl, meta_ComponentBase_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentBase, Pred> ComponentBase_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentBase, Pred>(impl, meta_ComponentBase_children); }
		Udm::ChildrenAttr< ::ESMoL::MessageRef> MessageRef_children() const { return Udm::ChildrenAttr< ::ESMoL::MessageRef>(impl, meta_MessageRef_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MessageRef, Pred> MessageRef_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MessageRef, Pred>(impl, meta_MessageRef_children); }
		Udm::ChildrenAttr< ::ESMoL::Connector> Connector_children() const { return Udm::ChildrenAttr< ::ESMoL::Connector>(impl, meta_Connector_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Connector, Pred> Connector_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Connector, Pred>(impl, meta_Connector_children); }
		Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base> CommMapping_Members_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred> CommMapping_Members_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CommMapping_Members_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base> MessageRef_RefersTo_Base_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base, Pred> MessageRef_RefersTo_Base_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MessageRef_RefersTo_Base, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::IOPortExp> IOPortExp_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::IOPortExp>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::IOPortExp, Pred> IOPortExp_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::IOPortExp, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Subsystem> Subsystem_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Subsystem>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred> Subsystem_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Executable> Executable_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Executable>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Executable, Pred> Executable_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Executable, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Connector> Connector_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Connector>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Connector, Pred> Connector_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Connector, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ComponentBase> ComponentBase_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ComponentBase>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ComponentBase, Pred> ComponentBase_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ComponentBase, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Output> Output_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Output>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Output, Pred> Output_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Output, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Input> Input_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Input>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Input, Pred> Input_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Input, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MessageRef> MessageRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MessageRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MessageRef, Pred> MessageRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MessageRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::CCode> CCode_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CCode>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CCode, Pred> CCode_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CCode, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::SubsystemRef> SubsystemRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::SubsystemRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::SubsystemRef, Pred> SubsystemRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::SubsystemRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::SystemTypes> SystemTypes_parent() const { return Udm::ParentAttr< ::ESMoL::SystemTypes>(impl, meta_SystemTypes_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Component(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_referedbyTaskRef;
		static ::Uml::CompositionChildRole meta_ComponentBase_children;
		static ::Uml::CompositionChildRole meta_MessageRef_children;
		static ::Uml::CompositionChildRole meta_Connector_children;
		static ::Uml::CompositionParentRole meta_SystemTypes_parent;

	};

	class ComponentBase :  virtual  public MgaObject {
	public:
		ComponentBase() {}
		ComponentBase(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		ComponentBase(const ComponentBase &master) : MgaObject(master), UDM_OBJECT(master) {}

		static ComponentBase Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ComponentBase Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ComponentBase CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ComponentBase> Instances() { return Udm::InstantiatedAttr<ComponentBase>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ComponentBase, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ComponentBase, Pred>(impl); }
		ComponentBase CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ComponentBase> Derived() { return Udm::DerivedAttr<ComponentBase>(impl); }
		template <class Pred> Udm::DerivedAttr<ComponentBase, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ComponentBase, Pred>(impl); }
		Udm::ArchetypeAttr<ComponentBase> Archetype() const { return Udm::ArchetypeAttr<ComponentBase>(impl); }
		Udm::IntegerAttr Deadline() const { return Udm::IntegerAttr(impl, meta_Deadline); }
		Udm::IntegerAttr Period() const { return Udm::IntegerAttr(impl, meta_Period); }
		Udm::ParentAttr< ::ESMoL::Component> Component_parent() const { return Udm::ParentAttr< ::ESMoL::Component>(impl, meta_Component_parent); }
		Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_parent() const { return Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLPARENTROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> MgaObject_parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Deadline;
		static ::Uml::Attribute meta_Period;
		static ::Uml::CompositionParentRole meta_Component_parent;

	};

	class Subsystem :  public Block,  public ComponentBase {
	public:
		Subsystem() {}
		Subsystem(Udm::ObjectImpl *impl) : Block(impl),ComponentBase(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Subsystem(const Subsystem &master) : Block(master),ComponentBase(master), MgaObject(master), UDM_OBJECT(master) {}

		static Subsystem Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Subsystem Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Subsystem CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Subsystem> Instances() { return Udm::InstantiatedAttr<Subsystem>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Subsystem, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Subsystem, Pred>(impl); }
		Subsystem CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Subsystem> Derived() { return Udm::DerivedAttr<Subsystem>(impl); }
		template <class Pred> Udm::DerivedAttr<Subsystem, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Subsystem, Pred>(impl); }
		Udm::ArchetypeAttr<Subsystem> Archetype() const { return Udm::ArchetypeAttr<Subsystem>(impl); }
		Udm::AssocAttr< ::ESMoL::SubsystemRef> referedbySubsystemRef() const { return Udm::AssocAttr< ::ESMoL::SubsystemRef>(impl, meta_referedbySubsystemRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::SubsystemRef, Pred> referedbySubsystemRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::SubsystemRef, Pred>(impl, meta_referedbySubsystemRef); }
		Udm::ChildrenAttr< ::ESMoL::Block> Block_children() const { return Udm::ChildrenAttr< ::ESMoL::Block>(impl, meta_Block_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Block, Pred> Block_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Block, Pred>(impl, meta_Block_children); }
		Udm::ChildrenAttr< ::ESMoL::Primitive> Primitive_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Primitive>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Primitive, Pred> Primitive_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Primitive, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Block> Block_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Block>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Block, Pred> Block_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Block, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Reference> Reference_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Reference>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Reference, Pred> Reference_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Reference, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Subsystem> Subsystem_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Subsystem>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred> Subsystem_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Subsystem, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::Dataflow> Dataflow_parent() const { return Udm::ParentAttr< ::ESMoL::Dataflow>(impl, meta_Dataflow_parent); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Subsystem(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_referedbySubsystemRef;
		static ::Uml::CompositionChildRole meta_Block_children;
		static ::Uml::CompositionParentRole meta_Dataflow_parent;

	};

	class Output :  virtual  public IOPortExp {
	public:
		Output() {}
		Output(Udm::ObjectImpl *impl) : IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Output(const Output &master) : IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static Output Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Output Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Output CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Output> Instances() { return Udm::InstantiatedAttr<Output>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Output, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Output, Pred>(impl); }
		Output CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Output> Derived() { return Udm::DerivedAttr<Output>(impl); }
		template <class Pred> Udm::DerivedAttr<Output, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Output, Pred>(impl); }
		Udm::ArchetypeAttr<Output> Archetype() const { return Udm::ArchetypeAttr<Output>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Input> dstConnector() const { return Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Input>(impl, meta_dstConnector, meta_dstConnector_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Input, Pred> dstConnector_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Input, Pred>(impl, meta_dstConnector, meta_dstConnector_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_dstConnector;
		static ::Uml::AssociationRole meta_dstConnector_rev;

	};

	class OutputPort :  public OutPort,  public Output {
	public:
		OutputPort() {}
		OutputPort(Udm::ObjectImpl *impl) : OutPort(impl),Output(impl), IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		OutputPort(const OutputPort &master) : OutPort(master),Output(master), IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static OutputPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static OutputPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		OutputPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<OutputPort> Instances() { return Udm::InstantiatedAttr<OutputPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<OutputPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<OutputPort, Pred>(impl); }
		OutputPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<OutputPort> Derived() { return Udm::DerivedAttr<OutputPort>(impl); }
		template <class Pred> Udm::DerivedAttr<OutputPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<OutputPort, Pred>(impl); }
		Udm::ArchetypeAttr<OutputPort> Archetype() const { return Udm::ArchetypeAttr<OutputPort>(impl); }
		Udm::IntegerAttr Number() const { return Udm::IntegerAttr(impl, meta_Number); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_OutputPort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Number;

	};

	class Input :  virtual  public IOPortExp {
	public:
		Input() {}
		Input(Udm::ObjectImpl *impl) : IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		Input(const Input &master) : IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static Input Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Input Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Input CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Input> Instances() { return Udm::InstantiatedAttr<Input>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Input, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Input, Pred>(impl); }
		Input CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Input> Derived() { return Udm::DerivedAttr<Input>(impl); }
		template <class Pred> Udm::DerivedAttr<Input, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Input, Pred>(impl); }
		Udm::ArchetypeAttr<Input> Archetype() const { return Udm::ArchetypeAttr<Input>(impl); }
		Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Output> srcConnector() const { return Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Output>(impl, meta_srcConnector, meta_srcConnector_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Output, Pred> srcConnector_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Connector, ::ESMoL::Output, Pred>(impl, meta_srcConnector, meta_srcConnector_rev); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_srcConnector;
		static ::Uml::AssociationRole meta_srcConnector_rev;

	};

	class InputPort :  public InPort,  public Input {
	public:
		InputPort() {}
		InputPort(Udm::ObjectImpl *impl) : InPort(impl),Input(impl), IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		InputPort(const InputPort &master) : InPort(master),Input(master), IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static InputPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static InputPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		InputPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<InputPort> Instances() { return Udm::InstantiatedAttr<InputPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<InputPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<InputPort, Pred>(impl); }
		InputPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<InputPort> Derived() { return Udm::DerivedAttr<InputPort>(impl); }
		template <class Pred> Udm::DerivedAttr<InputPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<InputPort, Pred>(impl); }
		Udm::ArchetypeAttr<InputPort> Archetype() const { return Udm::ArchetypeAttr<InputPort>(impl); }
		Udm::IntegerAttr Number() const { return Udm::IntegerAttr(impl, meta_Number); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_InputPort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Number;

	};

	class MsgPort :  public Output,  public Input {
	public:
		MsgPort() {}
		MsgPort(Udm::ObjectImpl *impl) : Output(impl),Input(impl), IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		MsgPort(const MsgPort &master) : Output(master),Input(master), IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static MsgPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static MsgPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		MsgPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<MsgPort> Instances() { return Udm::InstantiatedAttr<MsgPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<MsgPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<MsgPort, Pred>(impl); }
		MsgPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<MsgPort> Derived() { return Udm::DerivedAttr<MsgPort>(impl); }
		template <class Pred> Udm::DerivedAttr<MsgPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<MsgPort, Pred>(impl); }
		Udm::ArchetypeAttr<MsgPort> Archetype() const { return Udm::ArchetypeAttr<MsgPort>(impl); }
		Udm::IntegerAttr MsgPortNum() const { return Udm::IntegerAttr(impl, meta_MsgPortNum); }
		Udm::ParentAttr< ::ESMoL::Message> Message_parent() const { return Udm::ParentAttr< ::ESMoL::Message>(impl, meta_Message_parent); }
		Udm::ParentAttr< ::ESMoL::MessageRef_RefersTo_Base> MessageRef_RefersTo_Base_parent() const { return Udm::ParentAttr< ::ESMoL::MessageRef_RefersTo_Base>(impl, Udm::NULLPARENTROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> MgaObject_parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_MsgPort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_MsgPortNum;
		static ::Uml::CompositionParentRole meta_Message_parent;

	};

	class MessageRef :  public CommMapping_Members_Base,  public MessageRef_RefersTo_Base,  public Executable,  public Output,  public Input {
	public:
		MessageRef() {}
		MessageRef(Udm::ObjectImpl *impl) : CommMapping_Members_Base(impl),MessageRef_RefersTo_Base(impl),Executable(impl),Output(impl),Input(impl), IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		MessageRef(const MessageRef &master) : CommMapping_Members_Base(master),MessageRef_RefersTo_Base(master),Executable(master),Output(master),Input(master), IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static MessageRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static MessageRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		MessageRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<MessageRef> Instances() { return Udm::InstantiatedAttr<MessageRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<MessageRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<MessageRef, Pred>(impl); }
		MessageRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<MessageRef> Derived() { return Udm::DerivedAttr<MessageRef>(impl); }
		template <class Pred> Udm::DerivedAttr<MessageRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<MessageRef, Pred>(impl); }
		Udm::ArchetypeAttr<MessageRef> Archetype() const { return Udm::ArchetypeAttr<MessageRef>(impl); }
		Udm::PointerAttr< ::ESMoL::MessageRef_RefersTo_Base> ref() const { return Udm::PointerAttr< ::ESMoL::MessageRef_RefersTo_Base>(impl, meta_ref); }
		Udm::PointerAttr< ::ESMoL::Connector> cns() const { return Udm::PointerAttr< ::ESMoL::Connector>(impl, meta_cns); }
		Udm::PointerAttr< ::ESMoL::Connector> cnd() const { return Udm::PointerAttr< ::ESMoL::Connector>(impl, meta_cnd); }
		Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef> dstDependency() const { return Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef>(impl, meta_dstDependency, meta_dstDependency_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef, Pred> dstDependency_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef, Pred>(impl, meta_dstDependency, meta_dstDependency_rev); }
		Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef> srcDependency() const { return Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef>(impl, meta_srcDependency, meta_srcDependency_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef, Pred> srcDependency_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Dependency, ::ESMoL::MessageRef, Pred>(impl, meta_srcDependency, meta_srcDependency_rev); }
		Udm::ParentAttr< ::ESMoL::Component> Component_parent() const { return Udm::ParentAttr< ::ESMoL::Component>(impl, meta_Component_parent); }
		Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_parent() const { return Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLPARENTROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> MgaObject_parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_MessageRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;
		static ::Uml::AssociationRole meta_cns;
		static ::Uml::AssociationRole meta_cnd;
		static ::Uml::AssociationRole meta_dstDependency;
		static ::Uml::AssociationRole meta_dstDependency_rev;
		static ::Uml::AssociationRole meta_srcDependency;
		static ::Uml::AssociationRole meta_srcDependency_rev;
		static ::Uml::CompositionParentRole meta_Component_parent;

	};

	class TimingConstraint :  public MgaObject {
	public:
		TimingConstraint() {}
		TimingConstraint(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		TimingConstraint(const TimingConstraint &master) : MgaObject(master), UDM_OBJECT(master) {}

		static TimingConstraint Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TimingConstraint Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TimingConstraint CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TimingConstraint> Instances() { return Udm::InstantiatedAttr<TimingConstraint>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TimingConstraint, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TimingConstraint, Pred>(impl); }
		TimingConstraint CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TimingConstraint> Derived() { return Udm::DerivedAttr<TimingConstraint>(impl); }
		template <class Pred> Udm::DerivedAttr<TimingConstraint, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TimingConstraint, Pred>(impl); }
		Udm::ArchetypeAttr<TimingConstraint> Archetype() const { return Udm::ArchetypeAttr<TimingConstraint>(impl); }
		Udm::StringAttr Latency() const { return Udm::StringAttr(impl, meta_Latency); }
		Udm::ParentAttr< ::ESMoL::TimingSheet> TimingSheet_parent() const { return Udm::ParentAttr< ::ESMoL::TimingSheet>(impl, meta_TimingSheet_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::TaskRef> dstTimingConstraint_end() const { return Udm::AssocEndAttr< ::ESMoL::TaskRef>(impl, meta_dstTimingConstraint_end_); }
		Udm::AssocEndAttr< ::ESMoL::TaskRef> srcTimingConstraint_end() const { return Udm::AssocEndAttr< ::ESMoL::TaskRef>(impl, meta_srcTimingConstraint_end_); }
		void Accept(Visitor &v) { v.Visit_TimingConstraint(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Latency;
		static ::Uml::CompositionParentRole meta_TimingSheet_parent;
		static ::Uml::AssociationRole meta_dstTimingConstraint_end_;
		static ::Uml::AssociationRole meta_srcTimingConstraint_end_;

	};

	class TimingSheet :  public MgaObject {
	public:
		TimingSheet() {}
		TimingSheet(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		TimingSheet(const TimingSheet &master) : MgaObject(master), UDM_OBJECT(master) {}

		static TimingSheet Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TimingSheet Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TimingSheet CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TimingSheet> Instances() { return Udm::InstantiatedAttr<TimingSheet>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TimingSheet, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TimingSheet, Pred>(impl); }
		TimingSheet CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TimingSheet> Derived() { return Udm::DerivedAttr<TimingSheet>(impl); }
		template <class Pred> Udm::DerivedAttr<TimingSheet, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TimingSheet, Pred>(impl); }
		Udm::ArchetypeAttr<TimingSheet> Archetype() const { return Udm::ArchetypeAttr<TimingSheet>(impl); }
		Udm::ChildrenAttr< ::ESMoL::TimingConstraint> TimingConstraint_children() const { return Udm::ChildrenAttr< ::ESMoL::TimingConstraint>(impl, meta_TimingConstraint_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TimingConstraint, Pred> TimingConstraint_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TimingConstraint, Pred>(impl, meta_TimingConstraint_children); }
		Udm::ChildrenAttr< ::ESMoL::TaskRef> TaskRef_children() const { return Udm::ChildrenAttr< ::ESMoL::TaskRef>(impl, meta_TaskRef_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TaskRef, Pred> TaskRef_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TaskRef, Pred>(impl, meta_TaskRef_children); }
		Udm::ChildrenAttr< ::ESMoL::TimingConstraint> TimingConstraint_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TimingConstraint>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TimingConstraint, Pred> TimingConstraint_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TimingConstraint, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TaskRef> TaskRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TaskRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TaskRef, Pred> TaskRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TaskRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::DesignFolder> DesignFolder_parent() const { return Udm::ParentAttr< ::ESMoL::DesignFolder>(impl, meta_DesignFolder_parent); }
		Udm::ParentAttr< ::ESMoL::RequirementsLibrary> RequirementsLibrary_parent() const { return Udm::ParentAttr< ::ESMoL::RequirementsLibrary>(impl, meta_RequirementsLibrary_parent); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TimingSheet(*this); }

		static ::Uml::Class meta;
		static ::Uml::CompositionChildRole meta_TimingConstraint_children;
		static ::Uml::CompositionChildRole meta_TaskRef_children;
		static ::Uml::CompositionParentRole meta_DesignFolder_parent;
		static ::Uml::CompositionParentRole meta_RequirementsLibrary_parent;

	};

	class TaskRef :  public MgaObject {
	public:
		TaskRef() {}
		TaskRef(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		TaskRef(const TaskRef &master) : MgaObject(master), UDM_OBJECT(master) {}

		static TaskRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TaskRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TaskRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TaskRef> Instances() { return Udm::InstantiatedAttr<TaskRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TaskRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TaskRef, Pred>(impl); }
		TaskRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TaskRef> Derived() { return Udm::DerivedAttr<TaskRef>(impl); }
		template <class Pred> Udm::DerivedAttr<TaskRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TaskRef, Pred>(impl); }
		Udm::ArchetypeAttr<TaskRef> Archetype() const { return Udm::ArchetypeAttr<TaskRef>(impl); }
		Udm::PointerAttr< ::ESMoL::Component> ref() const { return Udm::PointerAttr< ::ESMoL::Component>(impl, meta_ref); }
		Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef> srcTimingConstraint() const { return Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef>(impl, meta_srcTimingConstraint, meta_srcTimingConstraint_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef, Pred> srcTimingConstraint_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef, Pred>(impl, meta_srcTimingConstraint, meta_srcTimingConstraint_rev); }
		Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef> dstTimingConstraint() const { return Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef>(impl, meta_dstTimingConstraint, meta_dstTimingConstraint_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef, Pred> dstTimingConstraint_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::TimingConstraint, ::ESMoL::TaskRef, Pred>(impl, meta_dstTimingConstraint, meta_dstTimingConstraint_rev); }
		Udm::ParentAttr< ::ESMoL::TimingSheet> TimingSheet_parent() const { return Udm::ParentAttr< ::ESMoL::TimingSheet>(impl, meta_TimingSheet_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TaskRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;
		static ::Uml::AssociationRole meta_srcTimingConstraint;
		static ::Uml::AssociationRole meta_srcTimingConstraint_rev;
		static ::Uml::AssociationRole meta_dstTimingConstraint;
		static ::Uml::AssociationRole meta_dstTimingConstraint_rev;
		static ::Uml::CompositionParentRole meta_TimingSheet_parent;

	};

	class CCode :  public ComponentBase {
	public:
		CCode() {}
		CCode(Udm::ObjectImpl *impl) : ComponentBase(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		CCode(const CCode &master) : ComponentBase(master), MgaObject(master), UDM_OBJECT(master) {}

		static CCode Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static CCode Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		CCode CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<CCode> Instances() { return Udm::InstantiatedAttr<CCode>(impl); }
		template <class Pred> Udm::InstantiatedAttr<CCode, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<CCode, Pred>(impl); }
		CCode CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<CCode> Derived() { return Udm::DerivedAttr<CCode>(impl); }
		template <class Pred> Udm::DerivedAttr<CCode, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<CCode, Pred>(impl); }
		Udm::ArchetypeAttr<CCode> Archetype() const { return Udm::ArchetypeAttr<CCode>(impl); }
		Udm::StringAttr CodeInfo() const { return Udm::StringAttr(impl, meta_CodeInfo); }
		Udm::ChildrenAttr< ::ESMoL::CInputPort> CInputPort_children() const { return Udm::ChildrenAttr< ::ESMoL::CInputPort>(impl, meta_CInputPort_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CInputPort, Pred> CInputPort_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CInputPort, Pred>(impl, meta_CInputPort_children); }
		Udm::ChildrenAttr< ::ESMoL::COutputPort> COutputPort_children() const { return Udm::ChildrenAttr< ::ESMoL::COutputPort>(impl, meta_COutputPort_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::COutputPort, Pred> COutputPort_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::COutputPort, Pred>(impl, meta_COutputPort_children); }
		Udm::ChildrenAttr< ::ESMoL::IOPortExp> IOPortExp_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::IOPortExp>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::IOPortExp, Pred> IOPortExp_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::IOPortExp, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Output> Output_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Output>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Output, Pred> Output_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Output, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Input> Input_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Input>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Input, Pred> Input_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Input, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::COutputPort> COutputPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::COutputPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::COutputPort, Pred> COutputPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::COutputPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::CInputPort> CInputPort_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::CInputPort>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::CInputPort, Pred> CInputPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::CInputPort, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_parent() const { return Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLPARENTROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> MgaObject_parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_CCode(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_CodeInfo;
		static ::Uml::CompositionChildRole meta_CInputPort_children;
		static ::Uml::CompositionChildRole meta_COutputPort_children;

	};

	class SubsystemRef :  public ComponentBase {
	public:
		SubsystemRef() {}
		SubsystemRef(Udm::ObjectImpl *impl) : ComponentBase(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		SubsystemRef(const SubsystemRef &master) : ComponentBase(master), MgaObject(master), UDM_OBJECT(master) {}

		static SubsystemRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static SubsystemRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		SubsystemRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<SubsystemRef> Instances() { return Udm::InstantiatedAttr<SubsystemRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<SubsystemRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SubsystemRef, Pred>(impl); }
		SubsystemRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<SubsystemRef> Derived() { return Udm::DerivedAttr<SubsystemRef>(impl); }
		template <class Pred> Udm::DerivedAttr<SubsystemRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SubsystemRef, Pred>(impl); }
		Udm::ArchetypeAttr<SubsystemRef> Archetype() const { return Udm::ArchetypeAttr<SubsystemRef>(impl); }
		Udm::PointerAttr< ::ESMoL::Subsystem> ref() const { return Udm::PointerAttr< ::ESMoL::Subsystem>(impl, meta_ref); }
		Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base> ComponentRef_RefersTo_Base_parent() const { return Udm::ParentAttr< ::ESMoL::ComponentRef_RefersTo_Base>(impl, Udm::NULLPARENTROLE); }
		Udm::ParentAttr< ::ESMoL::MgaObject> MgaObject_parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_SubsystemRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;

	};

	class COutputPort :  public Output {
	public:
		COutputPort() {}
		COutputPort(Udm::ObjectImpl *impl) : Output(impl), IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		COutputPort(const COutputPort &master) : Output(master), IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static COutputPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static COutputPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		COutputPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<COutputPort> Instances() { return Udm::InstantiatedAttr<COutputPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<COutputPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<COutputPort, Pred>(impl); }
		COutputPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<COutputPort> Derived() { return Udm::DerivedAttr<COutputPort>(impl); }
		template <class Pred> Udm::DerivedAttr<COutputPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<COutputPort, Pred>(impl); }
		Udm::ArchetypeAttr<COutputPort> Archetype() const { return Udm::ArchetypeAttr<COutputPort>(impl); }
		Udm::StringAttr CPortType() const { return Udm::StringAttr(impl, meta_CPortType); }
		Udm::ParentAttr< ::ESMoL::CCode> CCode_parent() const { return Udm::ParentAttr< ::ESMoL::CCode>(impl, meta_CCode_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_COutputPort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_CPortType;
		static ::Uml::CompositionParentRole meta_CCode_parent;

	};

	class CInputPort :  public Input {
	public:
		CInputPort() {}
		CInputPort(Udm::ObjectImpl *impl) : Input(impl), IOPortExp(impl), MgaObject(impl), UDM_OBJECT(impl) {}
		CInputPort(const CInputPort &master) : Input(master), IOPortExp(master), MgaObject(master), UDM_OBJECT(master) {}

		static CInputPort Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static CInputPort Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		CInputPort CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<CInputPort> Instances() { return Udm::InstantiatedAttr<CInputPort>(impl); }
		template <class Pred> Udm::InstantiatedAttr<CInputPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<CInputPort, Pred>(impl); }
		CInputPort CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<CInputPort> Derived() { return Udm::DerivedAttr<CInputPort>(impl); }
		template <class Pred> Udm::DerivedAttr<CInputPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<CInputPort, Pred>(impl); }
		Udm::ArchetypeAttr<CInputPort> Archetype() const { return Udm::ArchetypeAttr<CInputPort>(impl); }
		Udm::StringAttr CPortType() const { return Udm::StringAttr(impl, meta_CPortType); }
		Udm::ParentAttr< ::ESMoL::CCode> CCode_parent() const { return Udm::ParentAttr< ::ESMoL::CCode>(impl, meta_CCode_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_CInputPort(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_CPortType;
		static ::Uml::CompositionParentRole meta_CCode_parent;

	};

	class Transition :  public MgaObject {
	public:
		Transition() {}
		Transition(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		Transition(const Transition &master) : MgaObject(master), UDM_OBJECT(master) {}

		static Transition Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Transition Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Transition CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Transition> Instances() { return Udm::InstantiatedAttr<Transition>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Transition, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Transition, Pred>(impl); }
		Transition CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Transition> Derived() { return Udm::DerivedAttr<Transition>(impl); }
		template <class Pred> Udm::DerivedAttr<Transition, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Transition, Pred>(impl); }
		Udm::ArchetypeAttr<Transition> Archetype() const { return Udm::ArchetypeAttr<Transition>(impl); }
		Udm::StringAttr Guard() const { return Udm::StringAttr(impl, meta_Guard); }
		Udm::StringAttr Trigger() const { return Udm::StringAttr(impl, meta_Trigger); }
		Udm::StringAttr Action() const { return Udm::StringAttr(impl, meta_Action); }
		Udm::StringAttr ConditionAction() const { return Udm::StringAttr(impl, meta_ConditionAction); }
		Udm::StringAttr Order() const { return Udm::StringAttr(impl, meta_Order); }
		Udm::ParentAttr< ::ESMoL::State> Transition_State_parent() const { return Udm::ParentAttr< ::ESMoL::State>(impl, meta_Transition_State_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		Udm::AssocEndAttr< ::ESMoL::TransConnector> srcTransition_end() const { return Udm::AssocEndAttr< ::ESMoL::TransConnector>(impl, meta_srcTransition_end_); }
		Udm::AssocEndAttr< ::ESMoL::TransConnector> dstTransition_end() const { return Udm::AssocEndAttr< ::ESMoL::TransConnector>(impl, meta_dstTransition_end_); }
		void Accept(Visitor &v) { v.Visit_Transition(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Guard;
		static ::Uml::Attribute meta_Trigger;
		static ::Uml::Attribute meta_Action;
		static ::Uml::Attribute meta_ConditionAction;
		static ::Uml::Attribute meta_Order;
		static ::Uml::CompositionParentRole meta_Transition_State_parent;
		static ::Uml::AssociationRole meta_srcTransition_end_;
		static ::Uml::AssociationRole meta_dstTransition_end_;

	};

	class TransConnector :  public MgaObject {
	public:
		TransConnector() {}
		TransConnector(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		TransConnector(const TransConnector &master) : MgaObject(master), UDM_OBJECT(master) {}

		static TransConnector Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TransConnector Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TransConnector CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TransConnector> Instances() { return Udm::InstantiatedAttr<TransConnector>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TransConnector, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TransConnector, Pred>(impl); }
		TransConnector CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TransConnector> Derived() { return Udm::DerivedAttr<TransConnector>(impl); }
		template <class Pred> Udm::DerivedAttr<TransConnector, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TransConnector, Pred>(impl); }
		Udm::ArchetypeAttr<TransConnector> Archetype() const { return Udm::ArchetypeAttr<TransConnector>(impl); }
		Udm::AssocAttr< ::ESMoL::ConnectorRef> referedbyConnectorRef() const { return Udm::AssocAttr< ::ESMoL::ConnectorRef>(impl, meta_referedbyConnectorRef); }
		template <class Pred> Udm::AssocAttr< ::ESMoL::ConnectorRef, Pred> referedbyConnectorRef_sorted(const Pred &) const { return Udm::AssocAttr< ::ESMoL::ConnectorRef, Pred>(impl, meta_referedbyConnectorRef); }
		Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector> dstTransition() const { return Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector>(impl, meta_dstTransition, meta_dstTransition_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector, Pred> dstTransition_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector, Pred>(impl, meta_dstTransition, meta_dstTransition_rev); }
		Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector> srcTransition() const { return Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector>(impl, meta_srcTransition, meta_srcTransition_rev); }
		template <class Pred> Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector, Pred> srcTransition_sorted(const Pred &) const { return Udm::AClassAssocAttr< ::ESMoL::Transition, ::ESMoL::TransConnector, Pred>(impl, meta_srcTransition, meta_srcTransition_rev); }
		Udm::ParentAttr< ::ESMoL::State> State_parent() const { return Udm::ParentAttr< ::ESMoL::State>(impl, meta_State_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_referedbyConnectorRef;
		static ::Uml::AssociationRole meta_dstTransition;
		static ::Uml::AssociationRole meta_dstTransition_rev;
		static ::Uml::AssociationRole meta_srcTransition;
		static ::Uml::AssociationRole meta_srcTransition_rev;
		static ::Uml::CompositionParentRole meta_State_parent;

	};

	class State :  public TransConnector {
	public:
		State() {}
		State(Udm::ObjectImpl *impl) : TransConnector(impl), UDM_OBJECT(impl) {}
		State(const State &master) : TransConnector(master), UDM_OBJECT(master) {}

		static State Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static State Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		State CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<State> Instances() { return Udm::InstantiatedAttr<State>(impl); }
		template <class Pred> Udm::InstantiatedAttr<State, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<State, Pred>(impl); }
		State CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<State> Derived() { return Udm::DerivedAttr<State>(impl); }
		template <class Pred> Udm::DerivedAttr<State, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<State, Pred>(impl); }
		Udm::ArchetypeAttr<State> Archetype() const { return Udm::ArchetypeAttr<State>(impl); }
		Udm::StringAttr Name() const { return Udm::StringAttr(impl, meta_Name); }
		Udm::StringAttr Decomposition() const { return Udm::StringAttr(impl, meta_Decomposition); }
		Udm::StringAttr EnterAction() const { return Udm::StringAttr(impl, meta_EnterAction); }
		Udm::StringAttr DuringAction() const { return Udm::StringAttr(impl, meta_DuringAction); }
		Udm::StringAttr ExitAction() const { return Udm::StringAttr(impl, meta_ExitAction); }
		Udm::StringAttr Order() const { return Udm::StringAttr(impl, meta_Order); }
		Udm::ChildrenAttr< ::ESMoL::TransConnector> TransConnector_children() const { return Udm::ChildrenAttr< ::ESMoL::TransConnector>(impl, meta_TransConnector_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred> TransConnector_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred>(impl, meta_TransConnector_children); }
		Udm::ChildrenAttr< ::ESMoL::Transition> Transition() const { return Udm::ChildrenAttr< ::ESMoL::Transition>(impl, meta_Transition); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Transition, Pred> Transition_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Transition, Pred>(impl, meta_Transition); }
		Udm::ChildrenAttr< ::ESMoL::StateDE> StateDE_children() const { return Udm::ChildrenAttr< ::ESMoL::StateDE>(impl, meta_StateDE_children); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::StateDE, Pred> StateDE_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::StateDE, Pred>(impl, meta_StateDE_children); }
		Udm::ChildrenAttr< ::ESMoL::State> State_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::State>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::State, Pred> State_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::State, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Transition> Transition_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Transition>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Transition, Pred> Transition_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Transition, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::History> History_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::History>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::History, Pred> History_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::History, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TransStart> TransStart_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TransStart>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TransStart, Pred> TransStart_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TransStart, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Junction> Junction_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Junction>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Junction, Pred> Junction_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Junction, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::ConnectorRef> ConnectorRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::ConnectorRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::ConnectorRef, Pred> ConnectorRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::ConnectorRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::TransConnector> TransConnector_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TransConnector>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred> TransConnector_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TransConnector, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Data> Data_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Data>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Data, Pred> Data_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Data, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::Event> Event_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::Event>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::Event, Pred> Event_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::Event, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::StateDE> StateDE_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::StateDE>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::StateDE, Pred> StateDE_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::StateDE, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::Stateflow> Stateflow_parent() const { return Udm::ParentAttr< ::ESMoL::Stateflow>(impl, meta_Stateflow_parent); }
		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_State(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Name;
		static ::Uml::Attribute meta_Decomposition;
		static ::Uml::Attribute meta_EnterAction;
		static ::Uml::Attribute meta_DuringAction;
		static ::Uml::Attribute meta_ExitAction;
		static ::Uml::Attribute meta_Order;
		static ::Uml::CompositionChildRole meta_TransConnector_children;
		static ::Uml::CompositionChildRole meta_Transition;
		static ::Uml::CompositionChildRole meta_StateDE_children;
		static ::Uml::CompositionParentRole meta_Stateflow_parent;

	};

	class History :  public TransConnector {
	public:
		History() {}
		History(Udm::ObjectImpl *impl) : TransConnector(impl), UDM_OBJECT(impl) {}
		History(const History &master) : TransConnector(master), UDM_OBJECT(master) {}

		static History Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static History Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		History CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<History> Instances() { return Udm::InstantiatedAttr<History>(impl); }
		template <class Pred> Udm::InstantiatedAttr<History, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<History, Pred>(impl); }
		History CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<History> Derived() { return Udm::DerivedAttr<History>(impl); }
		template <class Pred> Udm::DerivedAttr<History, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<History, Pred>(impl); }
		Udm::ArchetypeAttr<History> Archetype() const { return Udm::ArchetypeAttr<History>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_History(*this); }

		static ::Uml::Class meta;

	};

	class TransStart :  public TransConnector {
	public:
		TransStart() {}
		TransStart(Udm::ObjectImpl *impl) : TransConnector(impl), UDM_OBJECT(impl) {}
		TransStart(const TransStart &master) : TransConnector(master), UDM_OBJECT(master) {}

		static TransStart Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static TransStart Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		TransStart CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<TransStart> Instances() { return Udm::InstantiatedAttr<TransStart>(impl); }
		template <class Pred> Udm::InstantiatedAttr<TransStart, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<TransStart, Pred>(impl); }
		TransStart CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<TransStart> Derived() { return Udm::DerivedAttr<TransStart>(impl); }
		template <class Pred> Udm::DerivedAttr<TransStart, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<TransStart, Pred>(impl); }
		Udm::ArchetypeAttr<TransStart> Archetype() const { return Udm::ArchetypeAttr<TransStart>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_TransStart(*this); }

		static ::Uml::Class meta;

	};

	class Junction :  public TransConnector {
	public:
		Junction() {}
		Junction(Udm::ObjectImpl *impl) : TransConnector(impl), UDM_OBJECT(impl) {}
		Junction(const Junction &master) : TransConnector(master), UDM_OBJECT(master) {}

		static Junction Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Junction Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Junction CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Junction> Instances() { return Udm::InstantiatedAttr<Junction>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Junction, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Junction, Pred>(impl); }
		Junction CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Junction> Derived() { return Udm::DerivedAttr<Junction>(impl); }
		template <class Pred> Udm::DerivedAttr<Junction, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Junction, Pred>(impl); }
		Udm::ArchetypeAttr<Junction> Archetype() const { return Udm::ArchetypeAttr<Junction>(impl); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Junction(*this); }

		static ::Uml::Class meta;

	};

	class ConnectorRef :  public TransConnector {
	public:
		ConnectorRef() {}
		ConnectorRef(Udm::ObjectImpl *impl) : TransConnector(impl), UDM_OBJECT(impl) {}
		ConnectorRef(const ConnectorRef &master) : TransConnector(master), UDM_OBJECT(master) {}

		static ConnectorRef Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static ConnectorRef Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		ConnectorRef CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<ConnectorRef> Instances() { return Udm::InstantiatedAttr<ConnectorRef>(impl); }
		template <class Pred> Udm::InstantiatedAttr<ConnectorRef, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<ConnectorRef, Pred>(impl); }
		ConnectorRef CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<ConnectorRef> Derived() { return Udm::DerivedAttr<ConnectorRef>(impl); }
		template <class Pred> Udm::DerivedAttr<ConnectorRef, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<ConnectorRef, Pred>(impl); }
		Udm::ArchetypeAttr<ConnectorRef> Archetype() const { return Udm::ArchetypeAttr<ConnectorRef>(impl); }
		Udm::PointerAttr< ::ESMoL::TransConnector> ref() const { return Udm::PointerAttr< ::ESMoL::TransConnector>(impl, meta_ref); }
		Udm::ParentAttr< ::ESMoL::Block> Block_parent() const { return Udm::ParentAttr< ::ESMoL::Block>(impl, meta_Block_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_ConnectorRef(*this); }

		static ::Uml::Class meta;
		static ::Uml::AssociationRole meta_ref;
		static ::Uml::CompositionParentRole meta_Block_parent;

	};

	class StateDE :  public MgaObject {
	public:
		StateDE() {}
		StateDE(Udm::ObjectImpl *impl) : MgaObject(impl), UDM_OBJECT(impl) {}
		StateDE(const StateDE &master) : MgaObject(master), UDM_OBJECT(master) {}

		static StateDE Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static StateDE Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		StateDE CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<StateDE> Instances() { return Udm::InstantiatedAttr<StateDE>(impl); }
		template <class Pred> Udm::InstantiatedAttr<StateDE, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<StateDE, Pred>(impl); }
		StateDE CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<StateDE> Derived() { return Udm::DerivedAttr<StateDE>(impl); }
		template <class Pred> Udm::DerivedAttr<StateDE, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<StateDE, Pred>(impl); }
		Udm::ArchetypeAttr<StateDE> Archetype() const { return Udm::ArchetypeAttr<StateDE>(impl); }
		Udm::ChildAttr< ::ESMoL::TypeBaseRef> TypeBaseRef_child() const { return Udm::ChildAttr< ::ESMoL::TypeBaseRef>(impl, meta_TypeBaseRef_child); }
		Udm::ChildrenAttr< ::ESMoL::TypeBaseRef> TypeBaseRef_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred> TypeBaseRef_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::TypeBaseRef, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ChildrenAttr< ::ESMoL::MgaObject> MgaObject_kind_children() const { return Udm::ChildrenAttr< ::ESMoL::MgaObject>(impl, Udm::NULLCHILDROLE); }
		template <class Pred> Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred> MgaObject_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr< ::ESMoL::MgaObject, Pred>(impl, Udm::NULLCHILDROLE); }
		Udm::ParentAttr< ::ESMoL::State> State_parent() const { return Udm::ParentAttr< ::ESMoL::State>(impl, meta_State_parent); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }

		static ::Uml::Class meta;
		static ::Uml::CompositionChildRole meta_TypeBaseRef_child;
		static ::Uml::CompositionParentRole meta_State_parent;

	};

	class Data :  public StateDE {
	public:
		Data() {}
		Data(Udm::ObjectImpl *impl) : StateDE(impl), UDM_OBJECT(impl) {}
		Data(const Data &master) : StateDE(master), UDM_OBJECT(master) {}

		static Data Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Data Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Data CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Data> Instances() { return Udm::InstantiatedAttr<Data>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Data, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Data, Pred>(impl); }
		Data CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Data> Derived() { return Udm::DerivedAttr<Data>(impl); }
		template <class Pred> Udm::DerivedAttr<Data, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Data, Pred>(impl); }
		Udm::ArchetypeAttr<Data> Archetype() const { return Udm::ArchetypeAttr<Data>(impl); }
		Udm::StringAttr Name() const { return Udm::StringAttr(impl, meta_Name); }
		Udm::StringAttr Description() const { return Udm::StringAttr(impl, meta_Description); }
		Udm::StringAttr DataType() const { return Udm::StringAttr(impl, meta_DataType); }
		Udm::IntegerAttr Port() const { return Udm::IntegerAttr(impl, meta_Port); }
		Udm::StringAttr Units() const { return Udm::StringAttr(impl, meta_Units); }
		Udm::StringAttr InitialValue() const { return Udm::StringAttr(impl, meta_InitialValue); }
		Udm::StringAttr Min() const { return Udm::StringAttr(impl, meta_Min); }
		Udm::StringAttr Max() const { return Udm::StringAttr(impl, meta_Max); }
		Udm::StringAttr ArraySize() const { return Udm::StringAttr(impl, meta_ArraySize); }
		Udm::StringAttr ArrayFirstIndex() const { return Udm::StringAttr(impl, meta_ArrayFirstIndex); }
		Udm::StringAttr Scope() const { return Udm::StringAttr(impl, meta_Scope); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Data(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Name;
		static ::Uml::Attribute meta_Description;
		static ::Uml::Attribute meta_DataType;
		static ::Uml::Attribute meta_Port;
		static ::Uml::Attribute meta_Units;
		static ::Uml::Attribute meta_InitialValue;
		static ::Uml::Attribute meta_Min;
		static ::Uml::Attribute meta_Max;
		static ::Uml::Attribute meta_ArraySize;
		static ::Uml::Attribute meta_ArrayFirstIndex;
		static ::Uml::Attribute meta_Scope;

	};

	class Event :  public StateDE {
	public:
		Event() {}
		Event(Udm::ObjectImpl *impl) : StateDE(impl), UDM_OBJECT(impl) {}
		Event(const Event &master) : StateDE(master), UDM_OBJECT(master) {}

		static Event Cast(const Udm::Object &a) { return __Cast(a, meta); }
		static Event Create(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }
		Event CreateInstance(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::InstantiatedAttr<Event> Instances() { return Udm::InstantiatedAttr<Event>(impl); }
		template <class Pred> Udm::InstantiatedAttr<Event, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<Event, Pred>(impl); }
		Event CreateDerived(const Udm::Object &parent, const ::Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }
		Udm::DerivedAttr<Event> Derived() { return Udm::DerivedAttr<Event>(impl); }
		template <class Pred> Udm::DerivedAttr<Event, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<Event, Pred>(impl); }
		Udm::ArchetypeAttr<Event> Archetype() const { return Udm::ArchetypeAttr<Event>(impl); }
		Udm::StringAttr Name() const { return Udm::StringAttr(impl, meta_Name); }
		Udm::StringAttr Description() const { return Udm::StringAttr(impl, meta_Description); }
		Udm::StringAttr Scope() const { return Udm::StringAttr(impl, meta_Scope); }
		Udm::StringAttr Trigger() const { return Udm::StringAttr(impl, meta_Trigger); }
		Udm::IntegerAttr Port() const { return Udm::IntegerAttr(impl, meta_Port); }
		Udm::ParentAttr< ::ESMoL::MgaObject> parent() const { return Udm::ParentAttr< ::ESMoL::MgaObject>(impl, Udm::NULLPARENTROLE); }
		void Accept(Visitor &v) { v.Visit_Event(*this); }

		static ::Uml::Class meta;
		static ::Uml::Attribute meta_Name;
		static ::Uml::Attribute meta_Description;
		static ::Uml::Attribute meta_Scope;
		static ::Uml::Attribute meta_Trigger;
		static ::Uml::Attribute meta_Port;

	};

}

#endif // MOBIES_ESMOL_H
